package rwd.concretesyntax.eulerdiagram;

import java.util.Vector;
import java.util.Iterator;
import java.util.LinkedHashSet;
import java.util.List;
import java.util.Set;

import rwd.utilities.AreaRWD;

/**
 * @author Octavian Patrascoiu
 *
 */
public class ConcreteZoneSet
	implements java.io.Serializable 
{   
	public ConcreteZoneSet() {
		// Add outer zone
		addZone(new ConcreteZone(new Vector(), new Vector()));
	}

	public ConcreteZoneSet(List zones) {
		_zones = new Vector(zones);
	}
    
	public List getZones() {
		return _zones;
	}
	/** Visible zones*/
	public Set getVisibleConcreteZones() {
		Object concreteZoneSet = null;
		Set result = new LinkedHashSet();
		Iterator i = _zones.iterator();
		while (i.hasNext()) {
			ConcreteZone cz = (ConcreteZone)i.next();
			AreaRWD area = cz.getArea();
			if (area != null) {
				if (!area.isEmpty())
					result.add(cz);
			} else {
				// Add outside area
//				result.add(cz); 
			}
		}
        //System.out.println("from "+_zones.size()+" zones, found "+result.size()+" visible ones");
		return result;
	}

	public void addZone(ConcreteZone c) {
		_zones.add(c);
	}

	public void removeZone(ConcreteZone z) {
		_zones.remove(z);
	}
    
	public ConcreteZoneSet getClone() {
		ConcreteZoneSet res = new ConcreteZoneSet();
		for(int i=0; i<_zones.size(); i++) {
			ConcreteZone item = (ConcreteZone)_zones.get(i);
			res.addZone((ConcreteZone)item.getClone());
		}
		return res;
	}
    
	// Local properties
	private List _zones = new Vector();
}
