package rwd.gui;

import java.awt.event.WindowEvent;
import javax.swing.JList;
import javax.swing.JButton;
import javax.swing.DefaultListModel;
import java.util.Vector;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;

import java.awt.event.KeyListener;
import java.awt.Dimension;
import java.awt.BorderLayout;
import java.awt.FlowLayout;

public class ChooserFromList extends FontFrame {
	private ChoiceGetter cg;
	private DefaultListModel listModel = new DefaultListModel();
	private JList choiceList;
	private FontScrollPane jScrollPane1;
	private JButton chooseButton = new JButton("select");
	private JButton clearButton = new JButton("clear");
	private JButton cancelButton = new JButton("cancel");
	private Vector choices;
	private Vector defaultChoices;
	private String title;
	private int choiceType;
	private boolean canChooseNone;
	private final FontFrame thisFrame = this;

	public ChooserFromList(
		String title,
		int choiceType,
		Vector choices,
		Vector defaultChoices,
		ChoiceGetter cg,
		boolean canChooseNone) {
		super(title);
		this.choiceType = choiceType;
		this.choices = choices;
		this.defaultChoices = defaultChoices;
		this.cg = cg;
		this.canChooseNone = canChooseNone;
		//System.out.println("choices is "+choices);
		initGUI();
		//System.out.println("finished building the chooserList");
	}

	/** This method is called from within the constructor to initialize the form. */
	private void initGUI() {
		addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent evt) {
				cg.formClosed();
			}
		});
		for (int i = 0; i < choices.size(); i++) {
			Object o = choices.get(i);
			listModel.add(i, o.toString());
		}
		choiceList = new JList(listModel);
		jScrollPane1 = new FontScrollPane(choiceList);
		choiceList.setSelectionMode(choiceType);
		//choiceList.setSelectedValue(listModel.get(0),true);
		int[] ints = new int[defaultChoices.size()];
		for (int i = 0; i < defaultChoices.size(); i++) {
			ints[i] = choices.indexOf(defaultChoices.get(i));
		}
		if (defaultChoices.size() == 0 && canChooseNone == false) {
			ints = new int[] { 0 };
		}
		choiceList.setSelectedIndices(ints);
		//final JList list = choiceList;
		jScrollPane1 = new FontScrollPane(choiceList);
		getContentPane().add(jScrollPane1, BorderLayout.CENTER);
		jScrollPane1.setPreferredSize(new Dimension(250, 200));
		choiceList.setBounds(new java.awt.Rectangle(48, 77, 32, 32));
		FontPanel buttonPanel = new FontPanel();
		buttonPanel.setLayout(new FlowLayout());
		getContentPane().add(buttonPanel, BorderLayout.SOUTH);
		chooseButton.setBounds(new java.awt.Rectangle(13, 208, 91, 34));
		chooseButton.setMnemonic(KeyEvent.VK_ENTER);
		clearButton.setBounds(new java.awt.Rectangle(106, 208, 91, 34));
		cancelButton.setBounds(new java.awt.Rectangle(198, 208, 78, 34));
		cancelButton.setMnemonic(KeyEvent.VK_ESCAPE);
		buttonPanel.add(chooseButton);
		buttonPanel.add(clearButton);
		buttonPanel.add(cancelButton);
		chooseButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				choose();
			}
		});
		clearButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				choiceList.clearSelection();
			}
		});
		if (!canChooseNone) {
			clearButton.setVisible(false);
		}
		cancelButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				thisFrame.hide();
				thisFrame.dispose();
			}
		});
		pack();
		//setBounds(new java.awt.Rectangle(0, 0, 293, 275));

		choiceList.addKeyListener(new KeyListener() {
			public void keyPressed(KeyEvent e) {
			}
			public void keyReleased(KeyEvent e) {
			}
			public void keyTyped(KeyEvent e) {
				System.out.println("key");
				if (e.getKeyCode() == KeyEvent.VK_ENTER) {
					choose();
				}
			}
		});
	}
	private void choose() {
		int[] places = choiceList.getSelectedIndices();
		Vector chosenItems = new Vector();
		for (int i = 0; i < places.length; i++) {
			chosenItems.add(choices.get(places[i]));
		}
		cg.choiceMade(chosenItems);
		thisFrame.setVisible(false);
		thisFrame.dispose();
	}

	/** Exit the Application */
	private void exitForm(WindowEvent evt) {
	}
}
