package rwd.gui;
import java.awt.event.WindowEvent;
import javax.swing.JList;
import javax.swing.JButton;
import javax.swing.DefaultListModel;
import java.util.Vector;
import javax.swing.ListSelectionModel;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import rwd.abstractsyntax.spiderdiagram.Diagram;
import rwd.rules.application.RuleApplicationSpec;
import rwd.rules.choicespec.RuleWithChoice;

public class RuleApplicationChooser extends FontFrame {
	private DefaultListModel listModel = new DefaultListModel();
	private FontScrollPane jScrollPane1;
	private JList ruleAppList;
	private JButton applyButton = new JButton();
	private JButton cancelButton = new JButton();
	private RuleWithChoice r;
	private Vector ruleAppPossibilities;
	private Diagram d;
	//private JTextField nameTF = new JTextField();
	//private JLabel nameLabel = new JLabel();

	public RuleApplicationChooser(RuleWithChoice r, Diagram d) {
		super("choose rwd.rules application");
		this.d = d;
		this.r = r;
		initGUI();
		//pack();
	}

	/** This method is called from within the constructor to initialize the form. */
	private void initGUI() {
		setTitle(r.name);
		addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent evt) {
				exitForm(evt);
			}
		});
		ruleAppPossibilities = r.getApplicationPossibilities(d);
		for (int i = 0; i < ruleAppPossibilities.size(); i++) {
			RuleApplicationSpec ras =
				(RuleApplicationSpec) (ruleAppPossibilities.get(i));
			listModel.add(i, ras.toString());
		}
		ruleAppList = new JList(listModel);
		ruleAppList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		ruleAppList.setSelectedValue(listModel.get(0), true);
		ruleAppList.addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent e) { //System.out.println("list selection changed");
				//System.out.println("ruleAppList.getSelectedValues() is ");
				//System.out.println(""+ruleAppList.getSelectedValues());
				try {
					if (ruleAppList.getSelectedValues().length == 0) {
						applyButton.setEnabled(false);
					} else {
						applyButton.setEnabled(true);
					}
				} catch (ArrayIndexOutOfBoundsException s) {
				}
			}
		});
		jScrollPane1 = new FontScrollPane(ruleAppList);
		getContentPane().setLayout(null);
		getContentPane().add(jScrollPane1);
		getContentPane().add(applyButton);
		getContentPane().add(cancelButton);
		//getContentPane().add(nameTF);
		//getContentPane().add(nameLabel);
		jScrollPane1.setBounds(new java.awt.Rectangle(14, 55, 265, 147));
		ruleAppList.setBounds(new java.awt.Rectangle(48, 77, 32, 32));
		applyButton.setText("apply");
		applyButton.setBounds(new java.awt.Rectangle(48, 210, 138, 34));
		final FontFrame thisRAC = this;
		applyButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				RuleApplicationSpec ras =
					(RuleApplicationSpec) ruleAppPossibilities.get(
						ruleAppList.getSelectedIndex());
				StaticObjects.mdf.doRule(r, ras);
				thisRAC.hide(); // KILL??
			}
		});
		cancelButton.setText("cancel");
		cancelButton.setBounds(new java.awt.Rectangle(193, 211, 78, 32));
		cancelButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				thisRAC.hide(); // KILL?
			}
		});
		setBounds(new java.awt.Rectangle(0, 0, 293, 275));
		//nameTF.setText("");
		//nameTF.setBounds(new java.awt.Rectangle(77,19,145,30));
		//nameLabel.setText("name:");
		//nameLabel.setBounds(new java.awt.Rectangle(11,20,61,30));
	}

	/** Exit the Application */
	private void exitForm(WindowEvent evt) {
	}
}
