package rwd.gui.editor;

import javax.swing.*;

import rwd.gui.editor.viewers.*;

import java.awt.*;
import java.io.File;

/**
 * @author  $Author: op $
 * @version $Id: EditorInternalFrame.java,v 1.12 2004/10/20 10:08:38 op Exp $
 */
public class EditorInternalFrame extends JInternalFrame {
    public EditorInternalFrame(int width, int height, DiagramViewerInterface viewer) {
        this.viewer = viewer;
        this.setSize(new Dimension(width, height));
        this.setClosable(true);
        this.setIconifiable(true);
        this.setMaximizable(true);
        this.setResizable(true);
        initComponents();
        
        String title = "Constraint diagram " + increment();
        this.setTitle(title);
        viewer.setTitle(title);
        
        this.setVisible(true);
    }

	public DiagramViewerInterface getViewer() {
		return viewer;
	}

    private void initComponents() {
    	JScrollPane scroll = new JScrollPane((JComponent)viewer); 
    	this.getContentPane().add(scroll);
    }
    
    private static int increment() {
        return ++number;
    }

	//
	// Getters and setters
	//
	public File getFile() {
		return file;
	}
	public void setFile(File file) {
		this.file = file;
	}

	//
	// Local properties
	//    
    private DiagramViewerInterface viewer;
    private File file;
    private static int number = 0;
}
