package rwd.gui.editor.listeners;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import rwd.gui.editor.EditorFrame;
import rwd.gui.editor.viewers.DiagramViewerInterface;
import rwd.views.abstracttoconcrete.forcemodel.SpiderPlacer;

/**
 * @author Octavian Patrascoiu
 *
 */
public class AutoSpiderListener implements ActionListener {
	public AutoSpiderListener(EditorFrame frame) {
		this.frame = frame;
	}
	
	public AutoSpiderListener(DiagramViewerInterface viewer) {
		this.viewer = viewer;
	}

	public void actionPerformed(ActionEvent e) {
		auto();
	}

	public void auto() {
		if (frame != null) viewer = frame.getCurrentViewer();
		if (viewer == null) return;
		SpiderPlacer placer = new SpiderPlacer(viewer);
		placer.embed();		
	}
	
	// Local variables
	private EditorFrame frame;
	private DiagramViewerInterface viewer;
}
