package rwd.gui.editor.listeners;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JFileChooser;

import rwd.concretesyntax.constraintdiagram.ConcreteTextBox;
import rwd.gui.editor.DiagramCanvas;
import rwd.gui.editor.EditorFrame;
import rwd.gui.editor.dialogs.TextBoxDialog;
import rwd.gui.editor.viewers.DiagramViewerInterface;

/**
 * @author Octavian Patrascoiu
 *
 */
public class DrawNewTextListener implements ActionListener {
	public DrawNewTextListener(EditorFrame frame, int type) {
		this.frame = frame;
	}
	
	public DrawNewTextListener(DiagramViewerInterface viewer, int type) {
		this.viewer = viewer;
		this.type = type;
	}

	public void actionPerformed(ActionEvent e) {
		if (frame != null) viewer = frame.getCurrentViewer();
		if (viewer == null) return;
		DiagramCanvas dc = viewer.getDiagramCanvas();
		if (dc == null) return;
		int x = (int)dc.getCurrentX();
		int y = (int)dc.getCurrentY();
		addNewText(type, x, y);
	}

	public void addNewText(int type, int x, int y) {
		if (frame != null) viewer = frame.getCurrentViewer();
		if (viewer == null) return;
		// Create a dialog to input text
		TextBoxDialog dialog = new TextBoxDialog(frame, "Comment", "");
		int returnVal = dialog.showOpenDialog(frame);
		if (returnVal == JFileChooser.APPROVE_OPTION) {
			String comment = dialog.getText();
			// Create a text
			ConcreteTextBox textBox = new ConcreteTextBox(type, x, y, comment);
			viewer.add(textBox);
				
			// Repaint image
			viewer.redrawImage();
		}		
	}
	
	// Local variables
	private String text = new String();
	private DiagramViewerInterface viewer;
	private int type;
	private EditorFrame frame; 
}

