package rwd.gui.editor.listeners;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import rwd.gui.editor.EditorFrame;
import rwd.gui.editor.viewers.DiagramViewerInterface;

/**
 * @author Octavian Patrascoiu
 *
 */
public class EditUndoRedoListener 
	implements ActionListener
{
	public EditUndoRedoListener(EditorFrame frame, int kind) {
		this.frame = frame;
		this.kind = kind;
	}
	
	public EditUndoRedoListener(DiagramViewerInterface viewer, int kind) {
		this.viewer = viewer;
		this.kind = kind;
	}

	public void actionPerformed(ActionEvent e) {
		undoRedo(kind);
	}

	public void undoRedo(int kind) {
		if (frame != null) viewer = frame.getCurrentViewer();
		if (viewer == null) return;
		if (kind == UNDO) {
			viewer.undo();			
		} else if (kind == REDO) {
			viewer.redo();			
		}
		
		// Repaint image
		viewer.redrawImage();
	}

	// Local variables
	public static final int UNDO = 1;
	public static final int REDO = 2;
	private EditorFrame frame;
	private DiagramViewerInterface viewer;
	private int kind;
}
