package rwd.gui.editor.listeners;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JOptionPane;

import rwd.gui.editor.EditorFrame;
import rwd.gui.editor.viewers.DiagramViewerInterface;

/**
 * @author Octavian Patrascoiu
 *
 */
public class EditZoomListener implements ActionListener {
	public EditZoomListener(EditorFrame frame, int type, int scale) {
		this.frame = frame;
		this.type = type;
		this.scale = scale;
	}
	
	public EditZoomListener(DiagramViewerInterface viewer, int type, int scale) {
		this.viewer = viewer;
		this.type = type;
		this.scale = scale;
	}

	public void actionPerformed(ActionEvent e) {
		if (frame != null) viewer = frame.getCurrentViewer();
		if (viewer == null) return;
		zoom();
	}
	
	public void zoom() {
		if (type == ZOOM_IN || type == ZOOM_OUT) {
			viewer.getDiagramCanvas().updateZoom(scale);
		} else {
			String text = JOptionPane.showInputDialog("Size", new Integer(scale));
			if (text == null || text.length() == 0) {
				return;
			}
			scale = Integer.parseInt(text);
			viewer.getDiagramCanvas().zoomScale(scale);
		}
	}

	public static final int ZOOM_IN = 1;
	public static final int ZOOM_OUT = 2;
	public static final int ZOOM = 3;
	 
	// Local variables
	private EditorFrame frame;
	private DiagramViewerInterface viewer;
	private int type;
	private int scale;
}
