package rwd.gui.editor.listeners;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

import rwd.concretesyntax.ConcreteUnitaryDiagram;
import rwd.gui.editor.EditorFrame;
import rwd.gui.editor.dialogs.AddPointsToDiagramDialog;

/**
 * @author Octavian Patrascoiu
 *
 */
public class FormatAddPointsToDiagramListener implements ActionListener {
	public FormatAddPointsToDiagramListener(EditorFrame frame) {
		this.frame = frame;
	}

	public void actionPerformed(ActionEvent e) {
		// Create a dialog to choose XMI and OCL files
		AddPointsToDiagramDialog dialog = new AddPointsToDiagramDialog(frame, "Add more points", frame.getLog());
		int returnVal = dialog.showOpenDialog(frame);
		if (returnVal == JFileChooser.APPROVE_OPTION) {
			// Get diagram name
			String name = dialog.getDiagramName();
			if (name != null) {
				// Get the concrete diagram
				ConcreteUnitaryDiagram cud = frame.getCUDCalled(name);
				
				if (cud != null) {
					// Get other options
					int numPoints = dialog.getPointNum();
					boolean isEqu = dialog.isEqualised();
				
					// Reset log
					frame.getLog().reset();

					// Add points and equalise it
					cud.addMorePoints(dialog.getPointNum());
					if (dialog.isEqualised()) {
						cud.equalisePointNumber();
					}
				} else {
					JOptionPane.showMessageDialog(frame, "Cannot find diagram '"+name+"'");
				}
			}
		}
	}

	// Local variables
	protected EditorFrame frame;
}
