package rwd.gui.editor.listeners;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JOptionPane;

import rwd.gui.editor.EditorFrame;
import rwd.gui.editor.viewers.DiagramViewerInterface;

/**
 * @author Octavian Patrascoiu
 *
 */
public class FormatThicknessListener implements ActionListener {
	public FormatThicknessListener(EditorFrame frame) {
		this.frame = frame;
	}
	
	public FormatThicknessListener(DiagramViewerInterface viewer) {
		this.viewer = viewer;
	}

	public void actionPerformed(ActionEvent e) {
		setThickness();
	}
	
	public void setThickness() {
		if (frame != null) viewer = frame.getCurrentViewer();
		if (viewer == null) return;
		float thickness = 0.0f;
		while (thickness <= 0.0f) {
			String input =
				JOptionPane.showInputDialog("Select Thickness");
			if (input == null) {
				return;
			}
			try {
				thickness = Float.parseFloat(input);
			} catch (NumberFormatException nfe) {
				// Do nothing; keep default value.
			}
		}
		viewer.setThickness(thickness);

		viewer.redrawImage();
		
		viewer.getControlPanel().enableButtons(viewer.getDiagramCanvas().getSelectedItems());
	}

	// Local variables
	private EditorFrame frame;
	private DiagramViewerInterface viewer;
}

