package rwd.gui.editor.listeners;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Vector;

import javax.swing.JOptionPane;

import rwd.abstractsyntax.eulerdiagram.Contour;
import rwd.abstractsyntax.eulerdiagram.Zone;
import rwd.abstractsyntax.spiderdiagram.UnitaryDiagram;
import rwd.gui.editor.EditorFrame;

/**
 * @author Octavian Patrascoiu
 *
 */
public class GeneratorCirculiserListener implements ActionListener {
	public GeneratorCirculiserListener(EditorFrame frame) {
		this.frame = frame;
	}

	public void actionPerformed(ActionEvent e) {
		String inputString =
			JOptionPane.showInputDialog(
				frame,
				"Please enter zone list",
				"a b c ab ac bc abc");

		if (inputString != null) {
			// This code to generate the AEDView is borrowed from another
			// class of Jean's - pjm2.
			Vector allContours = new Vector();
			letterLoop : for (
				int i = 0; i < inputString.length(); i++) {
				String letter = inputString.substring(i, i + 1);
				if (letter.equals(" ")) {
					continue letterLoop;
				} else {
					Contour c = Contour.getContour(letter);
					if (!allContours.contains(c)) {
						allContours.add(c);
					}
				}
			}

			int charPosition = 0;
			Vector zones = new Vector();
			zones.add(Zone.getZone(new Vector(), allContours));

			zoneLoop : while (charPosition < inputString.length()) {
				Vector containingContours = new Vector();
				contourLoop : while (
					charPosition < inputString.length()) {
					// extract character from inputString
					char ch = inputString.charAt(charPosition);
					charPosition++;
					if (ch != ' ') {
						containingContours.add(
							Contour.getContour("" + ch));
					} else {
						break contourLoop;
					}
				} // finished adding contours
				Vector excludingContours =
					(Vector) allContours.clone();
				excludingContours.removeAll(containingContours);
				zones.add(
					Zone.getZone(
						containingContours,
						excludingContours));
			} // finished adding zones

			UnitaryDiagram ud = new UnitaryDiagram(zones, "ud");
			frame.getLog().reportMessage(ud.toDebugString());
			if (frame.showAbstractDiagram(ud, true, false) == null) {
				JOptionPane.showMessageDialog(frame, "Can't be drawn");
			}
		}
	}

	// Local variables
	protected EditorFrame frame;
}
