package rwd.gui.editor.listeners;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JOptionPane;

import rwd.concretesyntax.eulerdiagram.ContourPolygonSet;
import rwd.gui.editor.EditorFrame;
import rwd.views.abstracttoconcrete.forcemodel.Diagram;
import rwd.views.abstracttoconcrete.forcemodel.Graph;
import rwd.views.abstracttoconcrete.forcemodel.layout.ForceLayout;
import rwd.views.abstracttoconcrete.forcemodel.layout.Layout;
import rwd.views.abstracttoconcrete.forcemodel.layout.RandomLayout;

/**
 * @author Octavian Patrascoiu
 *
 */
public class GeneratorForceListener implements ActionListener {
	public GeneratorForceListener(EditorFrame frame) {
		this.frame = frame;
	}

	public void actionPerformed(ActionEvent e) {
		String inputString =
			JOptionPane.showInputDialog(
				frame,
				"Please enter zone list.\nSome generated digrams (particularly large ones) may not be correct and may require regenerating or manual editing.",
				"a b c ab ac bc abc");

		if (inputString != null) {
			Graph graph = new Graph(inputString);
			Layout randomLayout = new RandomLayout(1000);
			// magic number
			randomLayout.apply(graph);

			Layout forceLayout =
				new ForceLayout(
					EditorFrame.SPRING_ITERATIONS,
					EditorFrame.IDEAL_EDGE_LENGTH,
					EditorFrame.MOVEMENT_SIZE,
					EditorFrame.MAX_REPULSION_DISTANCE);
			forceLayout.apply(graph);

			Diagram diagram = new Diagram(graph);
			diagram.addContours();

			ContourPolygonSet contourPolygonSet =
				new ContourPolygonSet(diagram.getContourPolygons());
			//frame.addViewer(contourPolygonSet);
		}
	}

	// Local variables
	protected EditorFrame frame;
}
