package rwd.gui.editor.listeners;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import rwd.abstractsyntax.spiderdiagram.UnitaryDiagram;
import rwd.gui.editor.EditorFrame;
import rwd.rules.UnitaryDiagramGetterRandom;

/**
 * @author Octavian Patrascoiu
 *
 */
public class GeneratorRandomListener implements ActionListener {
	public GeneratorRandomListener(EditorFrame frame) {
		this.frame = frame;
	}

	public void actionPerformed(ActionEvent e) {
		whileLoop : while (true) {
			UnitaryDiagram ud =
				new UnitaryDiagramGetterRandom(
					(int) (Math.random() * 3) + 1,
					(int) (Math.random() * 5),
					true,
					false)
					.getDiagram();
			if (ud.getCloneOfContourSet().size() < 2
				|| ud.getSpiders().size() == 0) {
				continue whileLoop;
			}
			if (frame.showAbstractDiagram(ud, true, false) != null) {
				break whileLoop;
			}
		}
	}

	// Local variables
	protected EditorFrame frame;
}
