package rwd.gui.editor.listeners;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

import rwd.abstractsyntax.spiderdiagram.UnitaryDiagram;
import rwd.gui.editor.EditorFrame;
import rwd.ocl.spiderdiagram.Ocl2SpiderDiagram;
import rwd.ocl.spiderdiagram.Ocl2SpiderDiagramDialog;

/**
 * @author Octavian Patrascoiu
 *
 */
public class MapOcl2SdListener implements ActionListener {
	public MapOcl2SdListener(EditorFrame frame) {
		this.frame = frame;
	}

	public void actionPerformed(ActionEvent e) {
		// Create a dialog to choose XMI and OCL files
		Ocl2SpiderDiagramDialog dialog = new Ocl2SpiderDiagramDialog(frame, "OCL2SD", frame.getLog());
		int returnVal = dialog.showOpenDialog(frame);
		if (returnVal == JFileChooser.APPROVE_OPTION) {
			String oclFileName = dialog.getOCLFileName();
			if (oclFileName != null) {
				// Create a SD generator
				Ocl2SpiderDiagram gen = new Ocl2SpiderDiagram(frame.getLog());

				// Generate the corresponding Spider Diagram
				UnitaryDiagram ud = gen.makeSD(oclFileName);
				if (frame.showAbstractDiagram(ud, true, false) == null) {
					JOptionPane.showMessageDialog(frame, "Can't be drawn");
				}
			}
		}
	}

	// Local variables
	protected EditorFrame frame;
}
