package rwd.gui.editor.listeners;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Vector;
import java.util.LinkedHashSet;

import rwd.abstractsyntax.spiderdiagram.Spider;
import rwd.concretesyntax.eulerdiagram.ConcreteZone;
import rwd.gui.editor.EditorFrame;
import rwd.gui.editor.viewers.DiagramViewerInterface;

/**
 * @author Octavian Patrascoiu
 *
 */
public class RandomSpiderListener implements ActionListener {
    public RandomSpiderListener(EditorFrame frame) {
        this.frame = frame;
    }

    public RandomSpiderListener(DiagramViewerInterface viewer) {
        this.viewer = viewer;
    }

    public void actionPerformed(ActionEvent e) {
        //random();
    }

    public void random() {
        if (frame != null)
            viewer = frame.getCurrentViewer();
        if (viewer == null)
            return;
        Vector zoneAreas = new Vector(viewer.getConcreteDiagram().getVisibleConcreteZones());
        LinkedHashSet zoneSet = new LinkedHashSet();
        for (int i = 0; i < 3; i++) {
            zoneSet.add(
                ((ConcreteZone) zoneAreas
                    .get((int) (Math.random() * zoneAreas.size())))
                    .getAbstractZone());
        }
        Spider spider = new Spider(new Vector(zoneSet));
        viewer.addSpider(zoneAreas, spider);

        viewer.redrawImage();
    }

    // Local variables
    private EditorFrame frame;
    private DiagramViewerInterface viewer;
}
