package rwd.gui.editor.listeners;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.List;

import javax.swing.JFileChooser;

import rwd.gui.editor.EditorFrame;
import rwd.tableaux.semantic.Options;
import rwd.tableaux.semantic.TableauDialogImpl;
import rwd.tableaux.semantic.TableauViewerImpl;

/**
 * @author Octavian Patrascoiu
 *
 */
public class ReasoningETableauListener implements ActionListener {
	public ReasoningETableauListener(EditorFrame frame) {
		this.frame = frame;
	}

	public void actionPerformed(ActionEvent e) {
		// Create a dialog to choose XMI and OCL files
		TableauDialogImpl dialog = new TableauDialogImpl(frame, "Exploring Tableau", frame.getLog());
		int returnVal = dialog.showOpenDialog(frame);
		if (returnVal == JFileChooser.APPROVE_OPTION) {
			Options opt = dialog.getOptions();
			String inputString = dialog.getLogicExp();
			if (inputString != null) {
				// Get all the abstract unitary diagrams
				List diagrams = frame.getConcreteDiagrams(frame.getDesktopPane());
	
				// Reset log
				frame.getLog().reset();
	
				// Create a tableau
				TableauViewerImpl tableau = new TableauViewerImpl(frame.getDesktopPane());
				tableau.viewExpandable(inputString, opt, diagrams, frame.getLog());
	
				// Add tableau to desktop					
				frame.getDesktopPane().add(tableau);
				tableau.moveToFront();
			}
		}
	}

	// Local variables
	protected EditorFrame frame;
}
