package rwd.gui.editor.listeners;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JOptionPane;

import rwd.concretesyntax.ConcreteUnitaryDiagram;
import rwd.gui.editor.EditorFrame;
import rwd.gui.editor.viewers.DiagramViewerComponent;
import rwd.gui.editor.viewers.DiagramViewerInterface;
import rwd.views.smoother.MetricSmootherParameterWindow;

/**
 * @author Octavian Patrascoiu
 *
 */
public class SmoothListener implements ActionListener {
	public SmoothListener(EditorFrame frame) {
		this.frame = frame;
	}
	
	public SmoothListener(DiagramViewerInterface viewer) {
		this.viewer = viewer;
	}

	public void actionPerformed(ActionEvent e) {
		smooth();
	}

	public void smooth() {
		if (frame != null) viewer = frame.getCurrentViewer();
		if (viewer == null) return;	
		// Get the concrete unitary diagram
		String name =
			JOptionPane.showInputDialog(
				frame,
				"Please enter name of diagram",
				"d1");

		if(name == null) {
			return;
		}

		// Get the CUD
		ConcreteUnitaryDiagram cud = null;
		if (frame != null) 
			cud = frame.getCUDCalled(name);
		else if (viewer != null)
			cud = viewer.getCUDCalled(name);
		if (cud == null) {
			JOptionPane.showMessageDialog(frame, "Cannot find diagram '"+name+"'");
			return ;
		} 
		
		// Lauch smoother
		((DiagramViewerComponent)viewer).setVisible(true);
		new MetricSmootherParameterWindow(frame, cud, (DiagramViewerInterface)viewer, false);
	}
	
	// Local variables
	private EditorFrame frame;
	private DiagramViewerInterface viewer;
}

