package rwd.gui.editor.readers;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.ObjectInputStream;

import javax.swing.JOptionPane;

import rwd.concretesyntax.ConcreteDiagram;

/**
 * @author Octavian Patrascoiu
 *
 */
public class SerialReader 
	implements DiagramReader
{
	// Read a list of abstract diagrams
	public void read(String fileName) {
		try {
			// Open file
			File file = new File(fileName);
			ObjectInputStream input =
				new ObjectInputStream(
					new BufferedInputStream(
						new FileInputStream(file)));

			// Read title
			title = (String) input.readObject();
			// Read diagram
			diagram = (ConcreteDiagram) input.readObject();
		} catch (Exception anye) {
			JOptionPane.showMessageDialog(
				null,
				"The constraint diagram could not be opened:\n\n"
					+ anye,
				"Could not open file",
				JOptionPane.ERROR_MESSAGE);
			anye.printStackTrace();
		}
	}
	
	/** Get the result of the read */
	public String getTitle() {
		return title;
	}

	public ConcreteDiagram getConcreteDiagram() {
		return diagram;
	}

	// Local variables
	protected String title = "";
	protected ConcreteDiagram diagram;
}


