package rwd.gui.editor.writers;

import java.io.File;

import javax.swing.JOptionPane;

import rwd.gui.editor.viewers.DiagramViewerInterface;
import uk.ac.kent.cs.kmf.util.ILog;

/**
 * @author Octavian Patrascoiu
 *
 */
public class EpsWriter 
	extends DiagramWriter
{
	/** Constructor */
	public EpsWriter(ILog log) {
		super(log);
	}
	
	public void write(String fileName, DiagramViewerInterface viewer) {
		write(new File(fileName), viewer);
	}
	public void write(File psFile, DiagramViewerInterface viewer) {
		// Save the file
		try {
	//			BufferedWriter output =
	//			new BufferedWriter(new FileWriter(file));
	//		output.write(viewer.getDiagramCanvas().getEPS());
	//		output.flush();
	//		output.close();
			// Create a JPG file
			ImageWriter jpgWriter = new ImageWriter(log, "jpg");
			File jpgFile = new File("temp.jpg");
			jpgWriter.write(jpgFile, viewer);
			// Invoke the converter
			Jpeg2Ps jpg2ps = new Jpeg2Ps(jpgFile, psFile, log);
			jpg2ps.convert();
			// Delete the temp file
			jpgFile.delete();
		} catch (Exception anye) {
			JOptionPane.showMessageDialog(
				null,
				"The EPS file could not be created:\n\n" + anye,
				"Could not write EPS",
				JOptionPane.ERROR_MESSAGE);
		}
	}
}
