package rwd.metrics;

import java.awt.Point;
import java.awt.Polygon;
import java.awt.Shape;
import java.awt.geom.GeneralPath;
import java.awt.geom.PathIterator;
import java.util.Vector;

import rwd.utilities.AreaRWD;

//import rwd.abstractsyntax.eulerdiagram.Zone;
//import rwd.concretesyntax.eulerdiagram.*;
//import rwd.concretesyntax.eulerdiagram.ConcreteContour;
/**
 * 
 * @author RWD, Richard Bosworth
 * 
 * @version 04-Aug-2005 14:44
 */
public class AreaPolygonAdapter {
	Polygon p;
	
	public static int BEZIER_CONTROL_DISTANCE = 30;

	public AreaPolygonAdapter(Polygon p) {
		this.p = p;
	}
	public Polygon polygon() {
		return p;
	}
	public int[] xs() {
		return p.xpoints;
	}
	public int[] ys() {
		return p.ypoints;
	}
	public boolean isEmpty() {
		return new AreaRWD(p).isEmpty();
	}

	public static Vector getPolygonsFor(Shape s) {
		Vector result = new Vector();
		Vector xs = new Vector();
		Vector ys = new Vector();
		double[] doubles = { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 };
		int firstx = 0, firsty = 0;
		int oldx = 0, oldy = 0;
		PathIterator p = s.getPathIterator(null);
		boolean isFirst = true;
		if (p.isDone()) {
			System.out.println("pathIterator is done straight away");
			return result;
		}
		while (!p.isDone()) {
			int segmentType = p.currentSegment(doubles);
			if (isFirst) {
				firstx = (int) doubles[0];
				firsty = (int) doubles[1];
				//System.out.println("("+firstx+","+firsty+") adding 1st");
				xs.add(new Integer((int) firstx));
				ys.add(new Integer((int) firsty));
				isFirst = false;
			} else if (
				((((double) (firstx)) - doubles[0])
					* (((double) (firstx)) - doubles[0])
					> 1.5
					|| (((double) (firsty)) - doubles[1])
						* (((double) (firsty)) - doubles[1])
						> 1.5)
					&& ((((double) (oldx)) - doubles[0])
						* (((double) (oldx)) - doubles[0])
						> 1.5
						|| (((double) (oldy)) - doubles[1])
							* (((double) (oldy)) - doubles[1])
							> 1.5)) {
				xs.add(new Integer((int) (doubles[0])));
				ys.add(new Integer((int) (doubles[1])));
			}

			if (segmentType == PathIterator.SEG_CLOSE) {
				int[] xpts = new int[xs.size()];
				int[] ypts = new int[ys.size()];
				for (int index = 0; index < xs.size(); index++) {
					xpts[index] = ((Integer) (xs.get(index))).intValue();
					ypts[index] = ((Integer) (ys.get(index))).intValue();
				}
				if (xpts.length > 2) // line added 26th Feb 03
					{
					result.add(new Polygon(xpts, ypts, xpts.length));
				}
				xs = new Vector();
				ys = new Vector();
				isFirst = true;
			} else {
				oldx = (int) doubles[0];
				oldy = (int) doubles[1];
			}
			p.next();
		}
		return result;
	}

/*	public static ZonePoly getZonePolyFor(
		Zone z,
		Vector inPolys,
		Vector outPolys) {
		if (inPolys.size() == 0) {
			return null;
		}

		AreaRWD a = new AreaRWD((Polygon) (inPolys.get(0)));
		// intersect with others
		for (int i = 1; i < inPolys.size(); i++) {
			Polygon other = (Polygon) (inPolys.get(i));
			a.intersect(new AreaRWD(other));
		}
		// subtract with others
		for (int i = 0; i < outPolys.size(); i++) {
			Polygon other = (Polygon) (outPolys.get(i));
			a.subtract(new AreaRWD(other));
		}
		if (a.isEmpty()) {
			return null;
		} else {
			Vector polys = getPolygonsFor(a);
			//System.out.println("area for zone "+z+" has bounds "+niceString(polys));
			// check that one polygon contains all others
			boolean oneContainsRest = false;
			Polygon container = null;
			iLoop : for (int i = 0; i < polys.size(); i++) {
				Polygon p1 = (Polygon) polys.get(i);
				for (int j = 0; j < polys.size(); j++) {
					if (i == j) {
						continue;
					}
					Polygon p2 = (Polygon) polys.get(j);
					AreaRWD atmp = new AreaRWD(p1);
					atmp.intersect(new AreaRWD(p2));
					//System.out.println("poly "+niceString(p1)+" intersect "+niceString(p2));
					//System.out.println("is "+atmp+ " with polys "+getPolygonsFor(atmp));
					if (getPolygonsFor(atmp).size() == 0) {
						continue iLoop;
					}
				}
				container = p1;
				oneContainsRest = true;
				break iLoop;
			}
			if (oneContainsRest) { //System.out.println("poly "+niceString(container)+" contains rest");
				return new ZonePoly(z, container, a);
			} else { //System.out.println("found a disconnected zone");
				return null;
			}
		}
	}
	*/
/*	public static ZoneArea getZoneAreaFor(
		Zone z,
		Vector inPolys,
		Vector outPolys) {
		if (inPolys.size() == 0) {
			return null;
		}

		AreaRWD a = new AreaRWD((Polygon) (inPolys.get(0)));
		// intersect with others
		for (int i = 1; i < inPolys.size(); i++) {
			Polygon other = (Polygon) (inPolys.get(i));
			a.intersect(new AreaRWD(other));
		}
		// subtract with others
		for (int i = 0; i < outPolys.size(); i++) {
			Polygon other = (Polygon) (outPolys.get(i));
			a.subtract(new AreaRWD(other));
		}
		if (a.isEmpty()) {
			return null;
		} else {
			Vector polys = getPolygonsFor(a);
			//System.out.println("area for zone "+z+" has bounds "+niceString(polys));
			// check that one polygon contains all others
			boolean oneContainsRest = false;
			iLoop : for (int i = 0; i < polys.size(); i++) {
				Polygon p1 = (Polygon) polys.get(i);
				for (int j = 0; j < polys.size(); j++) {
					if (i == j) {
						continue;
					}
					Polygon p2 = (Polygon) polys.get(j);
					AreaRWD atmp = new AreaRWD(p1);
					atmp.intersect(new AreaRWD(p2));
					//System.out.println("poly "+niceString(p1)+" intersect "+niceString(p2));
					//System.out.println("is "+atmp+ " with polys "+getPolygonsFor(atmp));
					if (getPolygonsFor(atmp).size() == 0) {
						continue iLoop;
					}
				}
				oneContainsRest = true;
				break iLoop;
			}
			if (oneContainsRest) { 
				return new ConcreteZone(z, a);
			} else { //System.out.println("found a disconnected zone");
				return null;
			}
		}
	}
	*/

	/**
	 * Takes a Polygon and returns its area. This assumes that the
	 * Polygon is closed and otherwise "valid".
	 */
	public static double getAreaOf(Polygon p) {
		int[] xs = p.xpoints;
		int[] ys = p.ypoints;
		int x1 = 0;
		int y1 = 0;
		int area = 0;
		for (int i = 0; i <= p.npoints; i++) {
			int x2 = xs[i % p.npoints];
			int y2 = ys[i % p.npoints];
			area += x1 * y2 - x2 * y1;
			x1 = x2;
			y1 = y2;
		}
		area /= 2.0;

		return (area < 0) ? -area : area;
	}

	public static double getAreaOfConnectedArea(AreaRWD a) {
		//System.out.println("getting area of "+a);
		// find polys and find outside one.
		Vector polys = getPolygonsFor(a);
		//System.out.println("got "+polys.size()+" polygon boundaries");
		// check that one polygon contains all others
		Polygon containingOne = null;
		iLoop : for (int i = 0; i < polys.size(); i++) {
			Polygon p1 = (Polygon) polys.get(i);
			for (int j = 0; j < polys.size(); j++) {
				if (i == j) {
					continue;
				}
				Polygon p2 = (Polygon) polys.get(j);
				AreaRWD atmp = new AreaRWD(p1);
				atmp.subtract(new AreaRWD(p2));
				if (atmp.isEmpty()) {
					continue iLoop;
				}
			}
			containingOne = p1;
			break iLoop;
		}
		//System.out.println("containing poly is "+containingOne);
		if (containingOne != null) {
			double wholeA = getAreaOf(containingOne);
			for (int i = 0; i < polys.size(); i++) {
				Polygon p = (Polygon) polys.get(i);
				if (p != containingOne) {
					wholeA = wholeA - getAreaOf(p);
				}
			}
			return wholeA;
		}
		return 0.0;
	}

	/**
	 * Returns a smoothed version of any shape by replacing each line
	 * segment with a bezier curve.
	 */
	public static Shape getSmoothedShape(
		Shape shape,
		float controlPointLength) {
		// Get each point out of the shape (ignoring the last two)
		Vector points = new Vector();
		PathIterator pi = shape.getPathIterator(null);
		//double[] ptInfo = null;
		while (!pi.isDone()) {
			double[] ptInfo = new double[6];
			pi.currentSegment(ptInfo);
			pi.next();
			points.add(ptInfo);
		}
		points.remove(points.size() - 1);

		// Our curved shape will be represented by a GeneralPath.
		// We look at 3 points in turn to work out the placement of bezier
		// control points for each point.
		GeneralPath path = new GeneralPath();
		double[] point1 = (double[]) points.get(points.size() - 1);
		float x1 = (float) point1[0];
		float y1 = (float) point1[1];
		double[] point2 = (double[]) points.get(0);
		float x2 = (float) point2[0];
		float y2 = (float) point2[1];
		for (int i = 1; i <= points.size(); i++) {
			double[] point3 = (double[]) points.get(i % points.size());
			float x3 = (float) point3[0];
			float y3 = (float) point3[1];
			float theta = (float) Math.atan2(y3 - y1, x3 - x1);

			double segmentLength1 =
				Math.sqrt((x2 - x1) * (x2 - x1) + (y2 - y1) * (y2 - y1));
			double segmentLength2 =
				Math.sqrt((x3 - x2) * (x3 - x2) + (y3 - y2) * (y3 - y2));

			//float dx = controlPointLength * (float)Math.cos(theta);
			//float dy = controlPointLength * (float)Math.sin(theta);
			float dx1 = (float) ((segmentLength1 / 2) * Math.cos(theta)) / 2;
			float dy1 = (float) ((segmentLength1 / 2) * Math.sin(theta)) / 2;
			float dx2 = (float) ((segmentLength2 / 2) * Math.cos(theta)) / 2;
			float dy2 = (float) ((segmentLength2 / 2) * Math.sin(theta)) / 2;

			point2[2] = x2 - dx1; // in
			point2[3] = y2 - dy1;
			point2[4] = x2 + dx2; // out
			point2[5] = y2 + dy2;

			point1 = point2;
			point2 = point3;
			x1 = (float) point1[0];
			y1 = (float) point1[1];
			x2 = (float) point2[0];
			y2 = (float) point2[1];
		}

		// Now create the actual curved line segments using the control points
		// that we have worked out.
		point1 = (double[]) points.get(0);
		path.moveTo((float) point1[0], (float) point1[1]);
		for (int i = 1; i <= points.size(); i++) {
			point2 = (double[]) points.get(i % points.size());
			path.curveTo(
				(float) point1[4],
				(float) point1[5],
				(float) point2[2],
				(float) point2[3],
				(float) point2[0],
				(float) point2[1]);
			point1 = point2;
		}

		return path;

	}

	/**
	 * Creating a smoothed shape with the getSmoothedShape method replaces
	 * each line segment with a Bezier curve.  This method returns a new
	 * Shape that has straight line segments that follow the control points
	 * of the smoothed version of the shape.
	 * I.e. for those line segments that are replaced by a Bezier curve
	 * which causes the shape to grow in volume, the curve will not fall
	 * outside of the new set of straight line segments.
	 */
	/*    public static Shape getSmoothedBoundingShape(Shape shape, float controlPointLength) {
	        // Get each point out of the shape (ignoring the last two)
	        Vector points = getPoints(shape);
	        
	        // Our bounding shape will be represented by a GeneralPath.
	        // We look at 3 points in turn to work out the placement of bezier
	        // control points for each point.
	        GeneralPath path = new GeneralPath();
	        double[] point1 = (double[])points.get(points.size() - 1);
	        float x1 = (float)point1[0];
	        float y1 = (float)point1[1];
	        double[] point2 = (double[])points.get(0);
	        float x2 = (float)point2[0];
	        float y2 = (float)point2[1];
	        for (int i = 1; i <= points.size(); i++) {
	            double[] point3 = (double[])points.get(i % points.size());
	            float x3 = (float)point3[0];
	            float y3 = (float)point3[1];
	            float theta = (float)Math.atan2(y3 - y1, x3 - x1);
	            
	            double segmentLength1 = Math.sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1));
	            double segmentLength2 = Math.sqrt((x3-x2)*(x3-x2)+(y3-y2)*(y3-y2));
	            
	            //System.out.println(theta + " " + x3 + " " + y3 + " vs " + x1 + " " + y1);
	            
	            //float dx = controlPointLength * (float)Math.cos(theta);
	            //float dy = controlPointLength * (float)Math.sin(theta);
	            float dx1 = (float) ((segmentLength1/2) * Math.cos(theta));
	            float dy1 = (float) ((segmentLength1/2) * Math.sin(theta));
	            float dx2 = (float) ((segmentLength2/2) * Math.cos(theta));
	            float dy2 = (float) ((segmentLength2/2) * Math.sin(theta));
	            
	            point2[2] = x2 - dx1;  // in
	            point2[3] = y2 - dy1;
	            point2[4] = x2 + dx2;  // out
	            point2[5] = y2 + dy2;
	            
	            point1 = point2;
	            point2 = point3;
	            x1 = (float)point1[0];
	            y1 = (float)point1[1];
	            x2 = (float)point2[0];
	            y2 = (float)point2[1];
	        }
	        
	        // Now create the actual curved line segments using the control points
	        // that we have worked out.
	        point1 = (double[])points.get(0);
	        path.moveTo((float)point1[0], (float)point1[1]);
	        for (int i = 1; i <= points.size(); i++) {
	            point2 = (double[])points.get(i % points.size());
	            path.lineTo((float)point1[4], (float)point1[5]);
	            path.lineTo((float)point2[2], (float)point2[3]);
	            path.lineTo((float)point2[0], (float)point2[1]);
	            //path.curveTo((float)point1[4], (float)point1[5],
	            //             (float)point2[2], (float)point2[3],
	            //             (float)point2[0], (float)point2[1]);
	            point1 = point2;
	        }
	        
	        return path;
	    }
	*/
	/**
	 * Returns the rightmost point in the shape. This is useful for
	 * positioning labels.
	 */
	public static int[] getRightmostPoint(Polygon poly) {
		int[] xs = poly.xpoints;
		int biggest = Integer.MIN_VALUE;
		int biggestIndex = -1;
		for (int index = 0; index < poly.npoints; index++) {
			if (biggest < xs[index]) {
				biggestIndex = index;
				biggest = xs[index];
			}
		}
		return new int[] { xs[biggestIndex], poly.ypoints[biggestIndex] };
	}

	/**
	 * @param poly polygon whose top point is to be found
	 * @return the top point in the shape.
	 * pre:  poly must have at least one point

	 */
	/*
	 * test: poly with at least two points
	 */
	public static Point getTopPoint(Polygon poly) {
		int smallest = Integer.MAX_VALUE;
		int smallestIndex = -1;
		for (int index = 0; index < poly.npoints; index++) {
			if (smallest > poly.ypoints[index]) {
				smallestIndex = index;
				smallest = poly.ypoints[index];
			}
		}
		return new Point( poly.xpoints[smallestIndex], poly.ypoints[smallestIndex]);
	}

	/**
	 * Determines whether a shape is drawn clockwise or not.
	 * Here we assume that we are given a polygon with no edge crossings.
	 * The polygon may be convex or concave.
	 */
	public static boolean isDrawnClockwise(Polygon param) {
		double sumOfTurnAngles = 0.0;
		int[] xs = param.xpoints;
		int[] ys = param.ypoints;
		for (int i = 0; i < param.npoints; i++) {
			int x1 = xs[i];
			int y1 = ys[i];
			int x2 = xs[(i + 1) % param.npoints];
			int y2 = ys[(i + 1) % param.npoints];
			int x3 = xs[(i + 2) % param.npoints];
			int y3 = ys[(i + 2) % param.npoints];

			double theta12 = Math.atan2(y2 - y1, x2 - x1);
			double theta23 = Math.atan2(y3 - y2, x3 - x2);

			double turnAngle = theta12 - theta23;
			if (turnAngle > Math.PI) {
				turnAngle -= 2 * Math.PI;
			} else if (turnAngle < -Math.PI) {
				turnAngle += 2 * Math.PI;
			}

			sumOfTurnAngles += turnAngle;

		}
		return sumOfTurnAngles > 0;
	}

	/**
	 * Returns true if a smoothed version of the digram represents the same
	 * information as the original.
	 */
/*	public static boolean isSSmoothedTheSame(ContourPolygonSet polygonSet) {
		Vector contourPolys = polygonSet.getContourPolys();
		boolean[] members = new boolean[contourPolys.size()];
		for (int setNum = 0; setNum < 2 << members.length; setNum++) {
			int size = 0;
			for (int i = 0; i < members.length; i++) {
				if (members[i]) {
					size++;
				}
			}

			// normal and smoothed areas.
			AreaRWD[] areas1 = new AreaRWD[size];
			AreaRWD[] areas2 = new AreaRWD[size];

			// fill the array
			int pos = 0;
			for (int i = 0; i < members.length; i++) {
				if (members[i]) {
					Shape s =
						((ConcreteContour) contourPolys.get(i)).getPolygon();
					areas1[pos] = new AreaRWD(s);
					areas2[pos] = new AreaRWD(getSmoothedShape(s, AreaPolygonAdapter.BEZIER_CONTROL_DISTANCE));
					pos++;
				}
			}

			if (size > 0) {
				AreaRWD intersection1 = null;
				AreaRWD intersection2 = null;
				for (int i = 0; i < size; i++) {
					if (members[i]) {
						if (intersection1 == null) {
							intersection1 = areas1[i];
						} else {
							intersection1.intersect(areas1[i]);
						}
						if (intersection2 == null) {
							intersection2 = areas2[i];
						} else {
							intersection2.intersect(areas2[i]);
						}
					}
				}
				if ((intersection1 == null && intersection2 != null)
					|| (intersection1 != null && intersection2 == null)
					|| (intersection1 != null
						&& intersection2 != null
						&& intersection1.isEmpty() != intersection2.isEmpty())) {
					return false;
				}
			}

			// jibble the bits to the next bit pattern
			int i = members.length - 1;
			while (i >= 0 && members[i]) {
				members[i] = false;
				i--;
			}
			if (i >= 0) {
				members[i] = true;
			}

		}

		// Nothing weird was found - they must be the same diagram.
		return true;
	}
	*/

	public String toString() {
		String result = "";
		for (int i = 0; i < this.xs().length; i++) {
			result = result + "(" + xs()[i] + "," + ys()[i] + ")";
		}
		return result;
	}

	public static String niceString(Polygon p) {
		String result = "";
		for (int j = 0; j < p.npoints; j++) {
			result += "(" + p.xpoints[j] + "," + p.ypoints[j] + ")";
		}
		return result;
	}

	public static String niceString(Vector polys) {
		String result = "";
		for (int i = 0; i < polys.size(); i++) {
			result += "\n";
			Polygon p = (Polygon) (polys.get(i));
			for (int j = 0; j < p.npoints; j++) {
				result += "(" + p.xpoints[j] + "," + p.ypoints[j] + ")";
			}
		}
		return result;
	}

	private static Polygon parsePts(String polyString) { // get polygon pts as (3,5)(6,7) etc
		Vector xsList = new Vector();
		Vector ysList = new Vector();
		while (polyString.length() > 0) { // should start "(" - remove this
			polyString = polyString.substring(1);
			// look for ","
			int commaPos = polyString.indexOf(",");
			// extract numString1
			String numString = polyString.substring(0, commaPos);
			//System.out.println("numstring is "+numString+" with "+numString.length()+" characters");
			xsList.add(new Integer(numString));
			polyString = polyString.substring(commaPos + 1); // takes "," too
			int closeBPos = polyString.indexOf(")");
			numString = polyString.substring(0, closeBPos);
			ysList.add(new Integer(numString));
			//System.out.println("numstring is "+numString+" with "+numString.length()+" characters");
			polyString = polyString.substring(closeBPos + 1); // takes ")" too
			//System.out.println("polyString is "+polyString);
		}
		//System.out.println("xsList is "+xsList);
		int n = xsList.size();
		int[] xs = new int[n];
		int[] ys = new int[n];
		for (int i = 0; i < n; i++) {
			xs[i] = ((Integer) (xsList.get(i))).intValue();
			ys[i] = ((Integer) (ysList.get(i))).intValue();
		}
		return new Polygon(xs, ys, n);
	}

	private static void moveToPts(
		Polygon p,
		String polyString) { // get polygon pts as (3,5)(6,7) etc
		int i = 0;
		while (polyString.length() > 0) { // should start "(" - remove this
			polyString = polyString.substring(1);
			// look for ","
			int commaPos = polyString.indexOf(",");
			// extract numString1
			String numString = polyString.substring(0, commaPos);
			//System.out.println("numstring is "+numString+" with "+numString.length()+" characters");
			p.xpoints[i] = new Integer(numString).intValue();
			polyString = polyString.substring(commaPos + 1); // takes "," too
			int closeBPos = polyString.indexOf(")");
			numString = polyString.substring(0, closeBPos);
			p.ypoints[i] = new Integer(numString).intValue();
			//System.out.println("numstring is "+numString+" with "+numString.length()+" characters");
			polyString = polyString.substring(closeBPos + 1); // takes ")" too
			//System.out.println("polyString is "+polyString);
			i++;
		}
	}
	
/*	public static void main(String args[]) {
		Vector inPolys = new Vector();
		Vector outPolys = new Vector();

		// example 1:
		// a simple intersection
		System.out.println("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
		inPolys.add(parsePts("(0,0)(20,0)(20,20)(0,20)"));
		inPolys.add(parsePts("(10,10)(30,10)(30,30)(10,30)"));
		System.out.println("(10,20)(20,20)(20,10)(10,10):"
		+ (getZonePolyFor(new OldZone(), inPolys, outPolys)));
		// example 2:
		// a simple subtraction
		System.out.println("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
		inPolys.clear();
		inPolys.add(parsePts("(0,0)(20,0)(20,10)(0,10)"));
		outPolys.add(parsePts("(10,15)(10,-5)(30,-5)(30,15)"));
		System.out.println(
			"(0,0)(10,0)(10,10)(0,10):"
				+ (getZonePolyFor(new OldZone(), inPolys, outPolys)));
		// example 3:
		// a two-set intersection
		System.out.println("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
		inPolys.clear();
		inPolys.add(parsePts("(0,0)(10,20)(20,10)(30,20)(40,0)"));
		inPolys.add(parsePts("(0,30)(10,10)(20,20)(30,10)(40,30)"));
		outPolys.clear();
		System.out.println(
			"two areas::" + (getZonePolyFor(new OldZone(), inPolys, outPolys)));
		// example 4:
		// a containing intersection
		System.out.println("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
		inPolys.clear();
		inPolys.add(parsePts("(0,0)(30,0)(0,30)(30,30)"));
		inPolys.add(parsePts("(10,10)(20,10)(20,20)(10,20)"));
		outPolys.clear();
		System.out.println(
			"(10,10)(20,10)(20,20)(10,20):"
				+ (getZonePolyFor(new OldZone(), inPolys, outPolys)));

		Vector polys;
		Contour a = Contour.getContour("a");
		Contour b = Contour.getContour("b");
		Contour c = Contour.getContour("c");
		Contour d = Contour.getContour("d");
		Polygon p;
		ConcreteContour cp;
		ContourPolygonSet polySet;
		//ZonePresenceChecker zpc;
		/////////// first build a contour and mutate to give a  fig of 8
		polys = new Vector();
		int[] x0s = { 0, 10, 10, 0 };
		int[] y0s = { 0, 0, 20, 20 };
		p = new Polygon(x0s, y0s, 4);
		cp = new ConcreteContour(a, p);
		polys.add(cp);
		polySet = new ContourPolygonSet(polys);
		polySet.calcZonePolys();

		System.out.println("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
		polys = new Vector();
		Polygon p1 =
			parsePts(
				"(422,877)(-761,174)(-950,216)(-1235,281)(-1400,0)"
					+ "(-1365,-311)(-1261,-606)(-1094,-872)(-873,-1094)(-607,-1261)"
					+ "(-311,-1364)(0,-1400)(311,-1364)(549,-1141)(422,-877)(339,-703)(761,607)");
		polys.add(new ConcreteContour(a, p1));
		Polygon p2 = parsePts("(-422,-877)(950,-216)(761,-607)(0,-974)");
		polys.add(new ConcreteContour(b, p2));
		Polygon p3 = parsePts("(-761,607)(-950,-216)(-761,-607)(-422,877)");
		polys.add(new ConcreteContour(c, p3));
		Polygon p4 =
			parsePts("(1235,281)(1261,606)(1094,872)(873,1094)(607,1261)(311,1364)(0,1266)(0,974)(0,0)(950,216)");
		polys.add(new ConcreteContour(d, p4));
		polySet = new ContourPolygonSet(polys);
		polySet.calcZonePolys();
		System.out.println("you have these zones " + polySet.getZonePolys());

		//// zone1:
		inPolys.clear();
		inPolys.add(p1);
		inPolys.add(p2);
		inPolys.add(p3);
		inPolys.add(p4);
		outPolys.clear();
		System.out.println(
			"1234-:" + (getZonePolyFor(new OldZone(), inPolys, outPolys)));

		//// zone2:
		inPolys.clear();
		inPolys.add(p1);
		inPolys.add(p2);
		inPolys.add(p4);
		outPolys.clear();
		outPolys.add(p3);
		System.out.println(
			"124-3:" + (getZonePolyFor(new OldZone(), inPolys, outPolys)));
		//// zone3:
		inPolys.clear();
		inPolys.add(p1);
		inPolys.add(p3);
		inPolys.add(p4);
		outPolys.clear();
		outPolys.add(p2);
		System.out.println(
			"134-2:" + (getZonePolyFor(new OldZone(), inPolys, outPolys)));
		//// zone4:
		inPolys.clear();
		inPolys.add(p2);
		inPolys.add(p3);
		inPolys.add(p4);
		outPolys.clear();
		outPolys.add(p1);
		System.out.println(
			"234-1:" + (getZonePolyFor(new OldZone(), inPolys, outPolys)));
		//// zone5:
		inPolys.clear();
		inPolys.add(p1);
		inPolys.add(p2);
		inPolys.add(p3);
		outPolys.clear();
		outPolys.add(p4);
		System.out.println(
			"123-4:" + (getZonePolyFor(new OldZone(), inPolys, outPolys)));
		//// zone6:
		inPolys.clear();
		inPolys.add(p1);
		inPolys.add(p2);
		outPolys.clear();
		outPolys.add(p3);
		outPolys.add(p4);
		System.out.println(
			"12-34:" + (getZonePolyFor(new OldZone(), inPolys, outPolys)));
		//// zone7:
		inPolys.clear();
		inPolys.add(p1);
		inPolys.add(p3);
		outPolys.clear();
		outPolys.add(p2);
		outPolys.add(p4);
		System.out.println(
			"13-24:" + (getZonePolyFor(new OldZone(), inPolys, outPolys)));
		//// zone8:
		inPolys.clear();
		inPolys.add(p1);
		inPolys.add(p4);
		outPolys.clear();
		outPolys.add(p2);
		outPolys.add(p3);
		System.out.println(
			"14-23:" + (getZonePolyFor(new OldZone(), inPolys, outPolys)));
		//// zone9:
		inPolys.clear();
		inPolys.add(p2);
		inPolys.add(p3);
		outPolys.clear();
		outPolys.add(p1);
		outPolys.add(p4);
		System.out.println(
			"23-14:" + (getZonePolyFor(new OldZone(), inPolys, outPolys)));
		//// zone10:
		inPolys.clear();
		inPolys.add(p2);
		inPolys.add(p4);
		outPolys.clear();
		outPolys.add(p1);
		outPolys.add(p3);
		System.out.println(
			"24-13:" + (getZonePolyFor(new OldZone(), inPolys, outPolys)));
		//// zone11:
		inPolys.clear();
		inPolys.add(p3);
		inPolys.add(p4);
		outPolys.clear();
		outPolys.add(p1);
		outPolys.add(p2);
		System.out.println(
			"34-12:" + (getZonePolyFor(new OldZone(), inPolys, outPolys)));
		//// zone12:
		inPolys.clear();
		inPolys.add(p4);
		outPolys.clear();
		outPolys.add(p1);
		outPolys.add(p2);
		outPolys.add(p3);
		System.out.println(
			"4-123:" + (getZonePolyFor(new OldZone(), inPolys, outPolys)));
		//// zone13:
		inPolys.clear();
		inPolys.add(p3);
		outPolys.clear();
		outPolys.add(p1);
		outPolys.add(p2);
		outPolys.add(p4);
		System.out.println(
			"3-124:" + (getZonePolyFor(new OldZone(), inPolys, outPolys)));
		//// zone14:
		inPolys.clear();
		inPolys.add(p2);
		outPolys.clear();
		outPolys.add(p1);
		outPolys.add(p3);
		outPolys.add(p4);
		System.out.println(
			"2-134:" + (getZonePolyFor(new OldZone(), inPolys, outPolys)));
		//// zone15:
		inPolys.clear();
		inPolys.add(p1);
		outPolys.clear();
		outPolys.add(p2);
		outPolys.add(p3);
		outPolys.add(p4);
		System.out.println(
			"1-234:" + (getZonePolyFor(new OldZone(), inPolys, outPolys)));
		//// zone16:
		inPolys.clear();
		outPolys.clear();
		outPolys.add(p1);
		outPolys.add(p2);
		outPolys.add(p3);
		outPolys.add(p4);
		System.out.println(
			"-1234:" + (getZonePolyFor(new OldZone(), inPolys, outPolys)));

		//System.out.println("built a polygon set with polygons "+polySet);
		System.out.println("# zone polys is " + polySet.getZonePolys().size());
		DiagramViewerComponent viewer = new DiagramViewerComponent(400, 400);
		JFrame frame = new JFrame("Diagram view");
		frame.getContentPane().add(viewer);
		frame.pack();
		frame.setVisible(true);
		viewer.draw(polySet);
	}
*/
	/*
	// test program
    // ------------

    private static void pr(String s) {
      System.out.println(s);
    }

    private static void hd(String s) {
      System.out.println("\n" + s + "\n");
    }

    private static void pg() {
      try {
        int i;
        System.out.print("next page? (CR)");
        do i = System.in.read(); while (i != '\n');
        System.out.println();
      }
      catch (Exception e) {System.out.println("raised exception : " + e);}
    }

    public static void main(String args[]) throws Exception {
    	hd("test of getTopPoint");
    	Polygon p = new Polygon();
    	p.addPoint(0,1);
    	p.addPoint(1,2);
    	p.addPoint(2,1);
    	p.addPoint(1,0);
    	pr("p="+niceString(p));
    	pg();
    	
    	pr("getTopPoint(p)="+getTopPoint(p));
    	pg();
    	
    }
    */

}
