package rwd.rules;

import java.util.Vector;

import rwd.abstractsyntax.spiderdiagram.*;

/**
 * @author jaf28
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class DiagramGetterWithoutNegation implements DiagramGetter {

    private UnitaryDiagramGetter[] udgs;
    int maxNumComps;

    DiagramGetterWithoutNegation(
        int numContours,
        int maxNumSpiders,
        int maxNumberComponents) {
        // build a unitary diagram getter
        //udgs=new UnitaryDiagramGetterRandom[numContours];
        //for(int i=1;i<=numContours;i++)
        //{ udgs[i-1]=new UnitaryDiagramGetterRandom(i, maxNumSpiders);
        //}
        udgs = new UnitaryDiagramGetterRandom[1];
        udgs[0] = new UnitaryDiagramGetterRandom(numContours, maxNumSpiders);
        maxNumComps = maxNumberComponents;
    }

    public Diagram getDiagram() {
        Diagram result = null;
        int numComps = (int)(Math.random()*maxNumComps)+1;
        //System.out.println("build a diagram with "+numComps+" leaves");
        Vector components = new Vector();
        compLoop:
        for(int i=0; i<numComps; i++){
            Diagram leaf = null;
            if(Math.random()<0.1){
                leaf = new FalseDiagram("f");
                //System.out.println("leaf is F");
            } else {
                leaf = udgs[0].getDiagram();
                //System.out.println("leaf is not F");
            }            
            components.add(leaf);
            // consider merging components
            if(components.size()>1 && Math.random()<0.5){
                // choose some components
                Vector sublists = Utilities.powerSet(components);
                int rand = (int)(Math.random()*sublists.size());
                Vector sublist = (Vector)sublists.get(rand);
                if(sublist.size()>1){
                    components.removeAll(sublist);
                    if(Math.random()<0.5){
                        components.add(new AndCompoundDiagram(sublist,"acd"));
                    } else {
                        components.add(new OrCompoundDiagram(sublist,"ocd"));
                    }
                }
            }            
        }
        if(components.size()==1){
            return (Diagram)components.get(0);
        } else {
            if(Math.random()<0.5){
                result = new AndCompoundDiagram(components,"acd");
            } else {
                result = new OrCompoundDiagram(components,"ocd");
            }
        }
        Vector leaves = result.getParts();
        for(int i=0; i<leaves.size(); i++){
            Diagram leaf = (Diagram)leaves.get(i);
            if(leaf instanceof NotCompoundDiagram){
                throw new IllegalArgumentException();
            }
        }
        return result;        
    }
}
