package rwd.rules.autoproof;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Vector;
//import java.util.Vector;

import rwd.rules.*;
import rwd.rules.Proof;
//import rwd.rules.ProofGetterRandom;
import rwd.abstractsyntax.spiderdiagram.Diagram;
import rwd.abstractsyntax.spiderdiagram.DiagramFileUser;
import rwd.abstractsyntax.spiderdiagram.NotCompoundDiagram;
//import rwd.gui.ProofManager;

/**
 * @author jaf28
 */

public class AutoProofAssessor {

    public static void main(String[] args) {
        //System.out.println("start assessment");
        String dataFilename = args[0];
        int numberOfDataPoints = Integer.parseInt(args[1]);
        int numInitialContours = Integer.parseInt(args[2]);
        int maxNumContours = Integer.parseInt(args[2]);
        int numSpiders = Integer.parseInt(args[3]);
        int numComponents = Integer.parseInt(args[4]);
        int depthOfProofs = Integer.parseInt(args[5]);
        //int sizeHabitats = Integer.parseInt(args[6]);
        //int amountShading = Integer.parseInt(args[7]);

        try {
            BufferedWriter bfw =
                new BufferedWriter(new FileWriter(new File(dataFilename)));
            //ProofGetterSmall pgr =
            //    new ProofGetterSmall(
            //        numInitialContours,
            //        maxNumContours,
            //        numSpiders,
            //        numComponents,
            //        sizeHabitats,
            //        amountShading);
            ProofGetterWithoutNegation pgr =
                new ProofGetterWithoutNegation(
                    numInitialContours,
                    maxNumContours,
                    numSpiders,
                    numComponents);

            dataPointLoop : for (int i = 0; i < numberOfDataPoints; i++) {
                // get a proof
                Proof p = pgr.getProof(depthOfProofs);
                //System.out.println("pgr is "+pgr.getClass());
                //ProofManager.showNewProof(p,false,true);
                System.out.print("" + i);

                // pass the start/end diagrams to the proof-writer
                Diagram start = p.getFirstDiagram();
                Diagram target = p.getLastDiagram();

                int[] lengthBuilt = new int[] { 0, 0, 0, 0 };
                inversionloop : for (int j = 0; j < 2; j++) {
                    if (j == 1) {
                        //try {
                        //    p = ProofInverter.invertProof(p);
                        //} catch (IllegalArgumentException x) {
                        break inversionloop;
                        //}
                    }
                    Proof outcome1 = null;
                    try {
                        //System.out.println("searching for proof with worse proof writer : j is "+j);
                        Vector leaves = new Vector();
                        leaves.addAll(start.getParts());
                        leaves.addAll(target.getParts());
                        for (int il = 0; il < leaves.size(); il++) {
                            Diagram leaf = (Diagram) leaves.get(il);
                            if (leaf instanceof NotCompoundDiagram) {
                                throw new IllegalArgumentException();
                            }
                        }
                        outcome1 =
                            AutoProofWriterWorse.writeProof(start, target);
                    } catch (NoProofException x) {
                        System.out.println("no proof found:1!!");
                        //DiagramFileUser.saveToFile(start);
                        //DiagramFileUser.saveToFile(target);
                        ProofFileUser.saveToFile(p);
                        return;
                    } catch (OutOfMemoryError x) {
                        System.out.println("memory problem 1" + x);
                        DiagramFileUser.saveToFile(start);
                        DiagramFileUser.saveToFile(target);
                    }
                    if (outcome1 == null) {
                        System.out.println("null proof found:1!!");
                        //DiagramFileUser.saveToFile(start);
                        //DiagramFileUser.saveToFile(target);
                        return;
                        //System.exit(0);
                    }
                    //System.out.println("got proof #1 length"+outcome1.numSteps());
                    lengthBuilt[0] = outcome1.numSteps();
                    System.out.print(" " + lengthBuilt[0]);

                    Proof outcome2 = null;
                    try {
                        outcome2 =
                            AutoProofWriterBetter.writeProof(start, target);
                    } catch (NoProofException x) {
                        System.out.println("no proof found:2!!");
                        DiagramFileUser.saveToFile(start);
                        DiagramFileUser.saveToFile(target);
                        System.exit(0);
                    } catch (OutOfMemoryError x) {
                        System.out.println("memory problem 2" + x);
                        DiagramFileUser.saveToFile(start);
                        DiagramFileUser.saveToFile(target);
                    }

                    if (outcome2 == null) {
                        System.out.println("null proof found:2!!");
                        System.exit(0);
                    }
                    lengthBuilt[1] = outcome2.numSteps();
                    System.out.print(" " + lengthBuilt[1]);

                    Proof outcome3 = null;
                    try {
                        outcome3 =
                            AutoProofWriterShortened.writeProof(start, target);
                    } catch (NoProofException x) {
                        System.out.println("no proof found:3!!");
                        DiagramFileUser.saveToFile(start);
                        DiagramFileUser.saveToFile(target);
                        System.exit(0);
                    } catch (OutOfMemoryError x) {
                        System.out.println("memory problem 3" + x);
                        DiagramFileUser.saveToFile(start);
                        DiagramFileUser.saveToFile(target);
                    }

                    if (outcome3 == null) {
                        System.out.println("null proof found:3!!");
                        System.exit(0);
                    }
                    lengthBuilt[2] = outcome3.numSteps();
                    System.out.print(" " + lengthBuilt[2]);

                    Proof outcome4 = null;
                    try {
                        outcome4 =
                            AutoProofWriterShortenedWithNegation.writeProof(
                                start,
                                target);
                    } catch (NoProofException x) {
                        System.out.println("no proof found:4!!");
                        DiagramFileUser.saveToFile(start);
                        DiagramFileUser.saveToFile(target);
                        System.exit(0);
                    } catch (OutOfMemoryError x) {
                        System.out.println("memory problem 4" + x);
                        DiagramFileUser.saveToFile(start);
                        DiagramFileUser.saveToFile(target);
                    }

                    if (outcome4 == null) {
                        System.out.println("null proof found:4!!");
                        System.exit(0);
                    }
                    lengthBuilt[3] = outcome4.numSteps();
                    System.out.print(" " + lengthBuilt[3]);

                    System.out.println("");
                    bfw.write(
                        "length is "
                            + lengthBuilt[0]
                            + ","
                            + lengthBuilt[1]
                            + ","
                            + lengthBuilt[2]
                            + ","
                            + lengthBuilt[3]);
                    bfw.newLine();
                }
            } // end of datapoint loop
            bfw.flush();
            bfw.close();
        } catch (IOException x) {
            System.out.println("io problem " + x);
            x.printStackTrace();
            System.exit(0);
        }
    }
}
