package rwd.rules.autoproof;

import rwd.abstractsyntax.eulerdiagram.Zone;
import rwd.abstractsyntax.spiderdiagram.Diagram;
import java.util.Vector;
import rwd.abstractsyntax.spiderdiagram.UnitaryDiagram;
import rwd.rules.Proof;
import rwd.rules.choicespec.RuleWithChoice;
import rwd.rules.choicespec.RuleExcludedMiddle;
import rwd.rules.application.RuleAppliesToZone;

public class BetaMaker {
	public static Proof betarise(Diagram d) {
		Diagram diag = d.getClone(); // used to say getClone()
		Proof p = new Proof(diag);
		RuleWithChoice r = (RuleWithChoice)RuleExcludedMiddle.getRule();
		partLoop : while (true) {
			Vector unitaryParts = diag.getUnitaryParts();
			for (int i = 0; i < unitaryParts.size(); i++) {
				UnitaryDiagram udpart = (UnitaryDiagram) unitaryParts.get(i);
				Vector specs = r.getApplicationPossibilities(udpart);
				for (int j = 0; j < specs.size(); j++) {
					RuleAppliesToZone spec = (RuleAppliesToZone) specs.get(j);
					Zone z = spec.z;
					// find out whether z is shaded or touched in part
					if (!udpart.aSpiderTouches(z)
						&& !udpart.containsShaded(
							z)) { //System.out.println("apply excluded middle");
						//System.out.println("part is "+spec.d.toDebugString());
						//System.out.println("whole is "+diag.hashCode());
						diag = r.applyRuleToPart(diag, spec);
						p.addStepAtEnd(r, spec, diag);
						continue partLoop;
					}
				} // gone through all possible specs for udpart
			} // gone through all possible udparts
			break partLoop;
		}
		return p;
	}
}
