package rwd.rules.autoproof;

import rwd.abstractsyntax.spiderdiagram.Diagram;
//import rwd.gui.ProofManager;
import rwd.rules.Proof;
import rwd.rules.Rule;
import rwd.rules.application.RuleApplicationSpec;
import rwd.rules.nospec.SimpleCombiningRule;
import rwd.rules.application.RuleAppliesToJustADiagram;
import rwd.rules.choicespec.TrueWithAndRule;

public class Combiner {
	public static Proof combineWherePossible(Diagram d) {
		Diagram diag = d.getClone();
		Proof p = new Proof(diag);
		Rule r1 = SimpleCombiningRule.getRule();
		partLoop : while (true) {
			Diagram part = r1.findApplicablePart(diag);
			//System.out.println("diag is \n" + diag.toSaveString());
			//System.out.println("applicable part is" + part);
			if (part == null) {
				break partLoop;
			}
			RuleApplicationSpec spec = new RuleAppliesToJustADiagram(part);
			diag = r1.applyRuleToPart(diag, spec);
			p.addStepAtEnd(r1, spec, diag);
		}
        Rule r2 = TrueWithAndRule.getRule();
        //ProofManager.showNewProof(p,false,true);
        partLoop : while (true) {
            Diagram part = r2.findApplicablePart(diag);
            //System.out.println("diag is \n" + diag.toSaveString());
            //System.out.println("applicable part is" + part);
            if (part == null) {
                break partLoop;
            }
            RuleApplicationSpec spec = new RuleAppliesToJustADiagram(part);
            diag = r2.applyRuleToPart(diag, spec);
            p.addStepAtEnd(r2, spec, diag);
        }
        //ProofManager.showNewProof(p,false,true);
		return p;
	}
}
