package rwd.rules.autoproof;

import rwd.abstractsyntax.spiderdiagram.Diagram;
import java.util.Vector;
import rwd.rules.Proof;
import rwd.rules.application.RuleApplicationSpec;
import rwd.rules.choicespec.RuleWithChoice;
import rwd.rules.choicespec.FalseWithOrRule;
import rwd.rules.choicespec.FalseWithAndRule;

public class FalseRemover {
	public static Proof removeFalse(Diagram d) {
		Diagram diag = d.getClone();
		Proof p = new Proof(diag);
		RuleWithChoice r = (RuleWithChoice)FalseWithAndRule.getRule();
		partLoop1 : while (true) {
			Diagram part = r.findApplicablePart(diag);
			if (part == null) {
				break partLoop1;
			}
			Vector specs = r.getApplicationPossibilities(part);
			RuleApplicationSpec spec = (RuleApplicationSpec) specs.get(0);
			diag = r.applyRuleToPart(diag, spec);
			p.addStepAtEnd(r, spec, diag);
		}
		r = (RuleWithChoice)FalseWithOrRule.getRule();
		partLoop2 : while (true) {
			Diagram part = r.findApplicablePart(diag);
			if (part == null) {
				break partLoop2;
			}
			Vector specs = r.getApplicationPossibilities(part);
			RuleApplicationSpec spec = (RuleApplicationSpec) specs.get(0);
			diag = r.applyRuleToPart(diag, spec);
			p.addStepAtEnd(r, spec, diag);
		}
		return p;
	}
}
