package rwd.rules.autoproof;

import rwd.abstractsyntax.spiderdiagram.Diagram;
import java.util.Vector;
import rwd.rules.Proof;
import rwd.rules.application.RuleApplicationSpec;
import rwd.rules.choicespec.RuleWithChoice;
import rwd.rules.choicespec.RuleDistributeAndOverOr;

public class SlowMakerOfDisNF {
	public static Proof turnToDisjNF(Diagram d) {
		Proof p = new Proof(d);
		RuleWithChoice rwc = (RuleWithChoice)RuleDistributeAndOverOr.getRule();
		partLoop : while (true) {
			Diagram part = rwc.findApplicablePart(d);
			//System.out.println("diag is \n" + d.toSaveString());
			//System.out.println("applicable part is" + part);
			if (part == null) {
				break partLoop;
			}
			Vector specs = rwc.getApplicationPossibilities(part);
			RuleApplicationSpec spec = (RuleApplicationSpec) specs.get(0);
			Diagram newd = rwc.applyRuleToPart(d, spec);
			p.addStepAtEnd(rwc, spec, newd);
			//System.out.println("application to part "+part.hashCode()+" of whole "
			//                  +d.hashCode()+" at coords "+d.getCoords(spec.d));
			d = newd;
		}
		return p;
	}
}
