package rwd.rules.choicespec;

import java.util.Vector;

import rwd.abstractsyntax.spiderdiagram.Diagram;
import rwd.rules.Rule;
import rwd.rules.application.RuleApplicationSpec;
import rwd.abstractsyntax.spiderdiagram.AndCompoundDiagram;
import rwd.rules.application.RuleAppliesToDiagramAndDiagram;

public class RuleAndForgetsInfo extends RuleWithChoice {
    private RuleAndForgetsInfo() {
        super("sd: PandQ->P");
    }
    private static Rule example = null;
    public static Rule getRule() {
        if (example == null) {
            example = new RuleAndForgetsInfo();
        }
        return example;
    }
    public boolean isInvertible() {
        return false;
    }

    public boolean canApplyTo(Diagram d) {
        return d instanceof AndCompoundDiagram;
    }

    public Vector getApplicationPossibilities(Diagram d) {
        Vector result = new Vector();
        // d must cast into an and-diagram
        if (d instanceof AndCompoundDiagram) {
            AndCompoundDiagram acd = (AndCompoundDiagram) d;
            Vector children = acd.getChildren();
            for (int i = 0; i < children.size(); i++) {
                Diagram child = (Diagram) children.get(i);
                result.add(new RuleAppliesToDiagramAndDiagram(acd, child));
            }
        }
        return result;
    }

    public Diagram applyRule(RuleApplicationSpec r) {
        RuleAppliesToDiagramAndDiagram radd =
            (RuleAppliesToDiagramAndDiagram) r;
        AndCompoundDiagram acd = (AndCompoundDiagram) radd.d;
        Vector children = (Vector) (acd.getChildren().clone());
        children.remove(radd.other);
        if (children.size() == 1) {
            return (Diagram) children.get(0);
        } else {
            return new AndCompoundDiagram(children, "outcome");
        }
    }
}
