/*
 * Created on 18-Dec-2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package rwd.rules.heuristics;

import java.util.Vector;

import rwd.abstractsyntax.spiderdiagram.NotCompoundDiagram;
import rwd.abstractsyntax.spiderdiagram.Spider;
import rwd.abstractsyntax.spiderdiagram.UnitaryDiagram;
import rwd.rules.Proof;
import rwd.rules.Rule;
import rwd.rules.application.RuleApplicationSpec;
import rwd.rules.application.RuleAppliesToDandDandD;
import rwd.rules.choicespec.MergeContradictionAvoidingFalseRule;
import rwd.rules.choicespec.RuleAddSpiderFoot;
import rwd.rules.choicespec.RuleExcludedMiddle;
import rwd.rules.choicespec.RuleJoinSpiders;
import rwd.rules.choicespec.RuleSplitSpider;
import rwd.rules.nospec.RemoveNotRule;

/**
 * @author jaf28
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class DefaultCompoundCostCalculator implements CostCalculator{
    public double cost(Proof p){
        p.goToStart();
        double total = 0.0;
        while(p.goToNextStep()){
            Rule r = p.getPreviousRule();
            //System.out.println("in cost calcualtor rule is "+r);
            if(r instanceof RuleExcludedMiddle){
                total = total + 3.0;
            } else if(r instanceof RuleSplitSpider){
                total = total + 4.0;
            } else if(r instanceof RuleJoinSpiders){
                total = total + 4.0;
            } else if(r instanceof RuleAddSpiderFoot){
                total = total + 2.0;
            } else if(r instanceof RemoveNotRule){
                RuleApplicationSpec ras = p.getPreviousRuleApplicationSpec();
                NotCompoundDiagram notD = (NotCompoundDiagram)ras.d;
                UnitaryDiagram uChild = (UnitaryDiagram)notD.getChildren().get(0);
                int numSpiders = uChild.getSpiders().size();
                total = total +(2*numSpiders + 2);
            } else if(r instanceof MergeContradictionAvoidingFalseRule){
                RuleApplicationSpec ras = p.getPreviousRuleApplicationSpec();
                RuleAppliesToDandDandD raddd = (RuleAppliesToDandDandD) ras;
                UnitaryDiagram d1 = (UnitaryDiagram) raddd.other1;
                UnitaryDiagram d2 = (UnitaryDiagram) raddd.other2;
                // a weak version here to make sure its admissible!!!
                //int numSpiders = d1.getSpiders().size();
                //numSpiders = numSpiders + d2.getSpiders().size();    
                Vector spiders1 = (Vector)d1.getSpiders().clone();
                Vector spiders2 = (Vector)d2.getSpiders().clone();
                int numSpiders = 0;
                for(int i=0; i<spiders1.size(); i++){
                    Spider s = (Spider)spiders1.get(i);
                    Vector habitat = s.getHabitat();
                    numSpiders ++;
                    Spider match = null;
                    matchLoop:
                    for(int j=0; j<spiders2.size(); j++){
                        Spider other = (Spider)spiders2.get(j);
                        Vector hab2 = other.getHabitat();
                        if(habitat.containsAll(hab2) && hab2.containsAll(habitat)){
                            match = other;
                            break matchLoop;
                        }
                    }
                    if(match!=null){
                        spiders2.remove(match);
                    }
                }
                numSpiders = numSpiders + spiders2.size();
                
                total = total +numSpiders + +d1.getCloneOfContourSet().size()+2;
            } else{
                total = total + 1.0;
            }
        }        
        return total;
    }
}
