package rwd.rules.inputspec;

import rwd.abstractsyntax.spiderdiagram.Diagram;
import rwd.abstractsyntax.spiderdiagram.FalseDiagram;
import rwd.rules.Rule;
import rwd.rules.application.RuleApplicationSpec;
import rwd.rules.application.RuleAppliesToDiagramAndDiagram;
import rwd.rules.choicespec.MergeContradictionRule;

public class RuleFalseImpliesAContradiction extends RuleNeedsInput {
	private RuleFalseImpliesAContradiction() {
		super("F->Contradiction");
	}
	private static Rule example = null;

	public static Rule getRule() {
		if (example == null) {
			example = new RuleFalseImpliesAContradiction();
		}
		return example;
	}
    public boolean isInvertible(){
        return true;
    }

	public Class getInputType() {
		try {
			return Class.forName("as.Diagram");
		} catch (ClassNotFoundException x) {
			return null;
		}
	}

	public boolean canApplyTo(Diagram d) {
		return d instanceof FalseDiagram;
	}

	public Diagram applyRule(RuleApplicationSpec r) {
		Diagram other = null;
		try {
			other = ((RuleAppliesToDiagramAndDiagram) r).other;
		} catch (ClassCastException e) {
		}
        if(!MergeContradictionRule.getRule().canApplyTo(other)){
            throw new IllegalArgumentException();
        }
		return other;
	}
}
