package rwd.rules.nospec;
import java.util.Vector;

import rwd.abstractsyntax.eulerdiagram.Zone;
import rwd.abstractsyntax.spiderdiagram.Diagram;
import rwd.abstractsyntax.spiderdiagram.FalseDiagram;
import rwd.abstractsyntax.spiderdiagram.NotCompoundDiagram;
import rwd.abstractsyntax.spiderdiagram.UnitaryDiagram;
import rwd.rules.Rule;
import rwd.rules.application.RuleApplicationSpec;

public class NotFalseIsTrueRule extends RuleNoSpec {
	private NotFalseIsTrueRule() {
		super("sd: Not(F) is True");
	}
	private static Rule example = null;

	public static Rule getRule() {
		if (example == null) {
			example = new NotFalseIsTrueRule();
		}
		return example;
	}
    public boolean isInvertible(){
        return true;
    }

	public boolean canApplyTo(Diagram d) {
        if(!(d instanceof NotCompoundDiagram)){
            return false;
        } else{
            Diagram child = (Diagram)(((NotCompoundDiagram)d).getChildren().get(0));
            if(!(child instanceof FalseDiagram)){
                return false;
            } else{
                return true;
            }
        }
	}
	public Diagram applyRule(RuleApplicationSpec r) {
        Vector zones = new Vector();
        Zone z = Zone.getZone(new Vector(), new Vector());
        zones.add(z);
		return new UnitaryDiagram(zones,"t");
	}
}
