package rwd.rules.nospec;

import rwd.abstractsyntax.spiderdiagram.Diagram;
import rwd.rules.Rule;
import rwd.rules.application.RuleApplicationSpec;
import rwd.rules.application.RuleAppliesToJustADiagram;
import java.util.Vector;
import rwd.abstractsyntax.spiderdiagram.UnitaryDiagram;
import rwd.abstractsyntax.spiderdiagram.Spider;
import rwd.rules.choicespec.RuleSplitSpider;
import rwd.rules.application.RuleAppliesToSpiderAndRegion;

public class ShatterSpidersRule extends RuleNoSpec {
	public ShatterSpidersRule() {
		super("sd: shatter all spiders");
	}
	private static Rule example = null;

	public static Rule getRule() {
		if (example == null) {
			example = new ShatterSpidersRule();
		}
		return example;
	}
    public boolean isInvertible(){
        return true;
    }

	public boolean canApplyTo(Diagram d) {
		return true;
	}

	public Diagram applyRule(RuleApplicationSpec r) {
		RuleAppliesToJustADiagram rajd = (RuleAppliesToJustADiagram) r;
		Diagram d = rajd.d;
		partLoop : while (true) {
			Vector parts = d.getUnitaryParts();
			for (int i = 0; i < parts.size(); i++) {
				UnitaryDiagram ud = (UnitaryDiagram) parts.get(i);
				Vector spiders = ud.getSpiders();
				for (int j = 0; j < spiders.size(); j++) {
					Spider s = (Spider) spiders.get(j);
					if (s.getHabitat().size() > 1) {
						Rule rss = RuleSplitSpider.getRule();
						Vector region = new Vector();
						region.add(s.getHabitat().get(0));
						RuleAppliesToSpiderAndRegion rasr =
							new RuleAppliesToSpiderAndRegion(ud, s, region);
						d = rss.applyRuleToPart(d, rasr);
						continue partLoop;
					}
				}
			}
			break partLoop;
		}
		return d;
	}
}
