package rwd.views.abstracttoconcrete.converting;
import rwd.views.graph.*;
import rwd.concretesyntax.ConcreteDiagram;
import rwd.concretesyntax.eulerdiagram.*;

import java.awt.Rectangle;

public class CompositeResult implements DrawableResult {
	AEDVTree tree;

	public CompositeResult(BlockTree bt) {
		//System.out.println("the CompositeResult constructor");
		//System.out.println("has been passed blockTree parameter:"+bt);
		//System.out.println("and will build an AEDVTree now.");
		tree = new AEDVTree(bt);
	}

	public void add(AEDView aed, BlockGraph bg) {
		//System.out.println("adding an AEDView to the CompositeResult");
		tree.add(aed, bg);
	}

	public AEDView getAEDV() {
		//System.out.println("getting an aedv");
		AEDView aedv = tree.getAEDView();
		aedv.scaleToFit(new Rectangle(-2*ConcreteDiagram.SCALE, -2*ConcreteDiagram.SCALE, 2*ConcreteDiagram.SCALE, 2*ConcreteDiagram.SCALE));
		return aedv;
	}

	public boolean isNested() {
		return tree.isMoreThanOneNode();
	}

	public String toString() {
		return "composite result tree is " + tree;
	}
}
