package rwd.views.graph;
import rwd.concretesyntax.ConcreteDiagram;

public class Position {
	private double x, y;

	public Position(double x, double y) {
		this.x = x;
		this.y = y;
	}

	public Position(int x, int y) {
		this.x = (double) x;
		this.y = (double) y;
	}

	public double getX() {
		return x;
	}
	public double getY() {
		return y;
	}

	public void setX(double x) {
		this.x = x;
	}
	public void setY(double y) {
		this.y = y;
	}

	public String toString() {
		return "(" + (int) x + "," + (int) y + ")";
	}

	public int compare(Position other) {
		if (x != other.x) {
			return getInt(x < other.x);
		} else if (y != other.y) {
			return getInt(y < other.y);
		} else
			return 0;
	}

	private int getInt(boolean b) {
		if (b) {
			return 1;
		} else {
			return -1;
		}
	}

	public static Position getRadialPosition(
		int n,
		int totalNum,
		double stepOut) {
		return new Position(
			(int) ((1 + stepOut) * ConcreteDiagram.SCALE * Math.cos(2 * Math.PI * n / totalNum)),
			(int) ((1 + stepOut)
				* ConcreteDiagram.SCALE
				* Math.sin(2 * Math.PI * n / totalNum)));
	}
}
