// Created on 17-Feb-2004

package rwd.views.smoother;


import rwd.concretesyntax.spiderdiagram.ConcreteSpiderFoot;

/**
 */
public class FootStep {

	public ConcreteSpiderFoot startFoot;
	public ConcreteSpiderFoot endFoot;
	public int steps;
	public double x;
	public double y;
	public double xStep;
	public double yStep;
	public int xStart;
	public int yStart;
	public int xEnd;
	public int yEnd;


	FootStep(ConcreteSpiderFoot startFoot, ConcreteSpiderFoot endFoot, int steps) {

		this.startFoot = startFoot;
		this.endFoot = endFoot;
		this.steps = steps;

		xStart = startFoot.getX();
		yStart = startFoot.getY();
		xEnd = endFoot.getX();
		yEnd = endFoot.getY();

		x = xStart;
		y = yStart;

		xStep = xEnd - xStart;
		xStep = xStep/steps;

		yStep = yEnd - yStart;
		yStep = yStep/steps;

	}



	public void doStep(ConcreteSpiderFoot foot, int numberOfSteps) {

		x += xStep*numberOfSteps;
		y += yStep*numberOfSteps;

		foot.setLocation((int)x,(int)y);
	}

}
