package rwd.views.smoother;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.OptionalDataException;
import java.net.URL;
import java.net.URLConnection;
import java.util.Vector;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;

import rwd.abstractsyntax.eulerdiagram.Zone;
import rwd.abstractsyntax.spiderdiagram.UnitaryDiagram;
import rwd.concretesyntax.eulerdiagram.AEDView;
import rwd.concretesyntax.eulerdiagram.ContourPolygonSet;
import rwd.gui.StaticObjects;
import rwd.views.abstracttoconcrete.converting.CompositeResult;
import rwd.views.abstracttoconcrete.converting.Diamond;
import rwd.views.abstracttoconcrete.converting.Result;
import rwd.views.abstracttoconcrete.converting.ResultDirector;

public class SmoothingDemoExampleGetter extends JFrame {
	public static void main(String args[]) {
//		if (args.length == 1) {
			generateViewFiles();
//			return;
//		}
		StaticObjects.setFontSize(14);
		SmoothingDemoExampleGetter frame = new SmoothingDemoExampleGetter();
		frame.setTitle("select examples");
		GridBagLayout myLayout = new GridBagLayout();
		frame.getContentPane().setLayout(myLayout);
		// You need a constraints object as well as a layout object
		GridBagConstraints myConstraints = new GridBagConstraints();
		myConstraints.insets = new Insets(2, 2, 2, 2);
		// padding between components
		//////////////////////////////////////////////////////////
		URL url =
			new ContourPolygonSet(new Vector())
				.getClass()
				.getClassLoader()
				.getResource(
				"Venn1.gif");
		JButton b = new JButton(new ImageIcon(url));
		b.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				setOff("Venn1.view");
			}
		});
		myConstraints.gridx = 0;
		myConstraints.gridy = 0;
		myLayout.setConstraints(b, myConstraints);
		frame.getContentPane().add(b);
		//////////////////////////////////////////////////////////
		url =
			new ContourPolygonSet(new Vector())
				.getClass()
				.getClassLoader()
				.getResource(
				"Venn2.gif");
		b = new JButton(new ImageIcon(url));
		b.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				setOff("Venn2.view");
			}
		});
		myConstraints.gridx = 1;
		myConstraints.gridy = 0;
		myLayout.setConstraints(b, myConstraints);
		frame.getContentPane().add(b);
		//////////////////////////////////////////////////////////
		url =
			new ContourPolygonSet(new Vector())
				.getClass()
				.getClassLoader()
				.getResource(
				"a_ab_b_bc_c.gif");
		b = new JButton(new ImageIcon(url));
		b.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				setOff("a_ab_b_bc_c.view");
			}
		});
		myConstraints.gridx = 0;
		myConstraints.gridy = 2;
		myLayout.setConstraints(b, myConstraints);
		frame.getContentPane().add(b);
		//////////////////////////////////////////////////////////
		url =
			new ContourPolygonSet(new Vector())
				.getClass()
				.getClassLoader()
				.getResource(
				"a_ab_b_abc_ac.gif");
		b = new JButton(new ImageIcon(url));
		b.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				setOff("a_ab_b_abc_ac.view");
			}
		});
		myConstraints.gridx = 1;
		myConstraints.gridy = 2;
		myLayout.setConstraints(b, myConstraints);
		frame.getContentPane().add(b);
		//////////////////////////////////////////////////////////
		url =
			new ContourPolygonSet(new Vector())
				.getClass()
				.getClassLoader()
				.getResource(
				"a_ab_b_bc_c_bcd_cd.gif");
		b = new JButton(new ImageIcon(url));
		b.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				setOff("a_ab_b_bc_c_bcd_cd.view");
			}
		});
		myConstraints.gridx = 0;
		myConstraints.gridy = 3;
		myLayout.setConstraints(b, myConstraints);
		frame.getContentPane().add(b);
		//////////////////////////////////////////////////////////
		url =
			new ContourPolygonSet(new Vector())
				.getClass()
				.getClassLoader()
				.getResource(
				"a_ab_b_bc_c_cd_d.gif");
		b = new JButton(new ImageIcon(url));
		b.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				setOff("a_ab_b_bc_c_cd_d.view");
			}
		});
		myConstraints.gridx = 1;
		myConstraints.gridy = 3;
		myLayout.setConstraints(b, myConstraints);
		frame.getContentPane().add(b);
		//////////////////////////////////////////////////////////
		url =
			new ContourPolygonSet(new Vector())
				.getClass()
				.getClassLoader()
				.getResource(
				"a_ab_abc_bc_b_bd_d.gif");
		b = new JButton(new ImageIcon(url));
		b.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				setOff("a_ab_abc_bc_b_bd_d.view");
			}
		});
		myConstraints.gridx = 0;
		myConstraints.gridy = 4;
		myLayout.setConstraints(b, myConstraints);
		frame.getContentPane().add(b);
		//////////////////////////////////////////////////////////
		url =
			new ContourPolygonSet(new Vector())
				.getClass()
				.getClassLoader()
				.getResource(
				"a_ab_b_bc_c_bd_d.gif");
		b = new JButton(new ImageIcon(url));
		b.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				setOff("a_ab_b_bc_c_bd_d.view");
			}
		});
		myConstraints.gridx = 1;
		myConstraints.gridy = 4;
		myLayout.setConstraints(b, myConstraints);
		frame.getContentPane().add(b);
		//////////////////////////////////////////////////////////
		url =
			new ContourPolygonSet(new Vector())
				.getClass()
				.getClassLoader()
				.getResource(
				"Venn3.gif");
		b = new JButton(new ImageIcon(url));
		b.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				setOff("Venn3.view");
			}
		});
		myConstraints.gridx = 0;
		myConstraints.gridy = 5;
		myLayout.setConstraints(b, myConstraints);
		frame.getContentPane().add(b);
		//////////////////////////////////////////////////////////
		url =
			new ContourPolygonSet(new Vector())
				.getClass()
				.getClassLoader()
				.getResource(
				"Venn4.gif");
		b = new JButton(new ImageIcon(url));
		b.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				setOff("Venn4.view");
			}
		});
		myConstraints.gridx = 1;
		myConstraints.gridy = 5;
		myLayout.setConstraints(b, myConstraints);
		frame.getContentPane().add(b);
		//////////////////////////////////////////////////////////

		frame.pack();
		frame.show();
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}

	public static void setOff(String fileName) {
		ObjectInputStream obin = null;
		try {
			URL url =
				new ContourPolygonSet(new Vector())
					.getClass()
					.getClassLoader()
					.getResource(
					fileName);
			URLConnection con = url.openConnection();
			con.setDoInput(true);
			con.setDoOutput(false);
			con.setUseCaches(false);
			obin = new ObjectInputStream(con.getInputStream());
		} catch (FileNotFoundException e) {
			say("file not found " + e);
		} catch (IOException e) {
			say("io problem " + e);
		}
		//System.out.println("got an object input stream");
		// now use the ObjectInputStream and get objects
		//System.out.println("this is what's in the file:");
		while (true) {
			Object o = null;
			try {
				o = obin.readObject();
			} catch (OptionalDataException e) {
				say("in setOff: optional data exception ???");
			} catch (ClassNotFoundException e) {
				say("in setOff: class not found " + e);
			} catch (IOException e) {
				say("in setoff: io exception " + e + " indicates last object");
				break;
			} // will cause exit from loop
			//System.out.println("about to build a smoothing demo object");
			new SmoothingDemo(
				(rwd.concretesyntax.eulerdiagram.AEDView) o,
				true);
			//System.out.println("built a smoothing demo object");
		}
	}

	public static void say(String message) {
		System.out.println(message);
	}

	public static void generateViewFiles() { 
        // build diagrams
		System.out.println("generating view files");
		try {
			Vector zones = new Vector();
			UnitaryDiagram ud;
			Result r;
			AEDView aedv;
			ObjectOutputStream oos;
			// Venn1
			zones.clear();
			zones.add(Zone.getZoneFor("", "a"));
			zones.add(Zone.getZoneFor("a", "a"));
			ud = new UnitaryDiagram(zones, "V1");
			r = new ResultDirector().makeResult(ud);
			//System.out.println("r is "+r.getClass());
			aedv = ((Diamond) r).getAEDV();
			oos = new ObjectOutputStream(new FileOutputStream("Venn1.view"));
			oos.writeObject(aedv);
			oos.writeObject(aedv);
			oos.close();
			// Venn2
			zones.clear();
			zones.add(Zone.getZoneFor("", "ab"));
			zones.add(Zone.getZoneFor("a", "ab"));
			zones.add(Zone.getZoneFor("b", "ab"));
			zones.add(Zone.getZoneFor("ab", "ab"));
			ud = new UnitaryDiagram(zones, "V2");
			aedv =
				((CompositeResult) new ResultDirector().makeResult(ud))
					.getAEDV();
			oos = new ObjectOutputStream(new FileOutputStream("Venn2.view"));
			oos.writeObject(aedv);
			oos.close();
			//a_ab_b_bc_c
			zones.clear();
			zones.add(Zone.getZoneFor("", "abc"));
			zones.add(Zone.getZoneFor("a", "abc"));
			zones.add(Zone.getZoneFor("ab", "abc"));
			zones.add(Zone.getZoneFor("b", "abc"));
			zones.add(Zone.getZoneFor("bc", "abc"));
			zones.add(Zone.getZoneFor("c", "abc"));
			ud = new UnitaryDiagram(zones, "ud");
			aedv =
				((CompositeResult) new ResultDirector().makeResult(ud))
					.getAEDV();
			oos =
				new ObjectOutputStream(
					new FileOutputStream("a_ab_b_bc_c.view"));
			oos.writeObject(aedv);
			oos.close();
			//a_ab_b_abc_ac.gif
			zones.clear();
			zones.add(Zone.getZoneFor("", "abc"));
			zones.add(Zone.getZoneFor("a", "abc"));
			zones.add(Zone.getZoneFor("ab", "abc"));
			zones.add(Zone.getZoneFor("b", "abc"));
			zones.add(Zone.getZoneFor("abc", "abc"));
			zones.add(Zone.getZoneFor("ac", "abc"));
			ud = new UnitaryDiagram(zones, "ud");
			aedv =
				((CompositeResult) new ResultDirector().makeResult(ud))
					.getAEDV();
			oos =
				new ObjectOutputStream(
					new FileOutputStream("a_ab_b_abc_ac.view"));
			oos.writeObject(aedv);
			oos.close();
			//a_ab_b_bc_c_bcd_cd
			zones.clear();
			zones.add(Zone.getZoneFor("", "abcd"));
			zones.add(Zone.getZoneFor("a", "abcd"));
			zones.add(Zone.getZoneFor("ab", "abcd"));
			zones.add(Zone.getZoneFor("b", "abcd"));
			zones.add(Zone.getZoneFor("bc", "abcd"));
			zones.add(Zone.getZoneFor("c", "abcd"));
			zones.add(Zone.getZoneFor("bcd", "abcd"));
			zones.add(Zone.getZoneFor("cd", "abcd"));
			ud = new UnitaryDiagram(zones, "ud");
			aedv =
				((CompositeResult) new ResultDirector().makeResult(ud))
					.getAEDV();
			oos =
				new ObjectOutputStream(
					new FileOutputStream("a_ab_b_bc_c_bcd_cd.view"));
			oos.writeObject(aedv);
			oos.close();
			//a_ab_b_bc_c_cd_d
			zones.clear();
			zones.add(Zone.getZoneFor("", "abcd"));
			zones.add(Zone.getZoneFor("a", "abcd"));
			zones.add(Zone.getZoneFor("ab", "abcd"));
			zones.add(Zone.getZoneFor("b", "abcd"));
			zones.add(Zone.getZoneFor("bc", "abcd"));
			zones.add(Zone.getZoneFor("c", "abcd"));
			zones.add(Zone.getZoneFor("cd", "abcd"));
			zones.add(Zone.getZoneFor("d", "abcd"));
			ud = new UnitaryDiagram(zones, "ud");
			aedv =
				((CompositeResult) new ResultDirector().makeResult(ud))
					.getAEDV();
			oos =
				new ObjectOutputStream(
					new FileOutputStream("a_ab_b_bc_c_cd_d.view"));
			oos.writeObject(aedv);
			oos.close();
			//a_ab_abc_bc_b_bd_d
			zones.clear();
			zones.add(Zone.getZoneFor("", "abcd"));
			zones.add(Zone.getZoneFor("a", "abcd"));
			zones.add(Zone.getZoneFor("ab", "abcd"));
			zones.add(Zone.getZoneFor("abc", "abcd"));
			zones.add(Zone.getZoneFor("bc", "abcd"));
			zones.add(Zone.getZoneFor("b", "abcd"));
			zones.add(Zone.getZoneFor("bd", "abcd"));
			zones.add(Zone.getZoneFor("d", "abcd"));
			ud = new UnitaryDiagram(zones, "ud");
			aedv =
				((CompositeResult) new ResultDirector().makeResult(ud))
					.getAEDV();
			oos =
				new ObjectOutputStream(
					new FileOutputStream("a_ab_abc_bc_b_bd_d.view"));
			oos.writeObject(aedv);
			oos.close();
			//a_ab_b_bc_c_bd_d
			zones.clear();
			zones.add(Zone.getZoneFor("", "abcd"));
			zones.add(Zone.getZoneFor("a", "abcd"));
			zones.add(Zone.getZoneFor("ab", "abcd"));
			zones.add(Zone.getZoneFor("b", "abcd"));
			zones.add(Zone.getZoneFor("bc", "abcd"));
			zones.add(Zone.getZoneFor("c", "abcd"));
			zones.add(Zone.getZoneFor("bd", "abcd"));
			zones.add(Zone.getZoneFor("d", "abcd"));
			ud = new UnitaryDiagram(zones, "ud");
			aedv =
				((CompositeResult) new ResultDirector().makeResult(ud))
					.getAEDV();
			oos =
				new ObjectOutputStream(
					new FileOutputStream("a_ab_b_bc_c_bd_d.view"));
			oos.writeObject(aedv);
			oos.close();
			//Venn3
			zones.clear();
			zones.add(Zone.getZoneFor("", "abc"));
			zones.add(Zone.getZoneFor("a", "abc"));
			zones.add(Zone.getZoneFor("ab", "abc"));
			zones.add(Zone.getZoneFor("b", "abc"));
			zones.add(Zone.getZoneFor("bc", "abc"));
			zones.add(Zone.getZoneFor("c", "abc"));
			zones.add(Zone.getZoneFor("ac", "abc"));
			zones.add(Zone.getZoneFor("abc", "abc"));
			ud = new UnitaryDiagram(zones, "ud");
			aedv =
				((CompositeResult) new ResultDirector().makeResult(ud))
					.getAEDV();
			oos = new ObjectOutputStream(new FileOutputStream("Venn3.view"));
			oos.writeObject(aedv);
			oos.close();
			//a_ab_b_bc_c_bd_d
			zones.clear();
			zones.add(Zone.getZoneFor("", "abcd"));
			zones.add(Zone.getZoneFor("a", "abcd"));
			zones.add(Zone.getZoneFor("b", "abcd"));
			zones.add(Zone.getZoneFor("c", "abcd"));
			zones.add(Zone.getZoneFor("d", "abcd"));
			zones.add(Zone.getZoneFor("ab", "abcd"));
			zones.add(Zone.getZoneFor("ac", "abcd"));
			zones.add(Zone.getZoneFor("ad", "abcd"));
			zones.add(Zone.getZoneFor("bc", "abcd"));
			zones.add(Zone.getZoneFor("bd", "abcd"));
			zones.add(Zone.getZoneFor("cd", "abcd"));
			zones.add(Zone.getZoneFor("abc", "abcd"));
			zones.add(Zone.getZoneFor("abd", "abcd"));
			zones.add(Zone.getZoneFor("acd", "abcd"));
			zones.add(Zone.getZoneFor("bcd", "abcd"));
			zones.add(Zone.getZoneFor("abcd", "abcd"));
			ud = new UnitaryDiagram(zones, "ud");
			aedv = ((CompositeResult) new ResultDirector().makeResult(ud)).getAEDV();
			oos = new ObjectOutputStream(new FileOutputStream("Venn4.view"));
			oos.writeObject(aedv);
			oos.close();
			//
		} catch (Exception e) {
			e.printStackTrace();
		}

	}
}
