/*
 * Created on 04-Dec-2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package rwd.views.smoother;

import java.util.Vector;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;

import rwd.abstractsyntax.eulerdiagram.Zone;
import rwd.concretesyntax.ConcreteUnitaryDiagram;
import rwd.concretesyntax.eulerdiagram.ConcreteZone;
import rwd.concretesyntax.spiderdiagram.ConcreteSpider;
import rwd.concretesyntax.spiderdiagram.ConcreteSpiderFoot;
import rwd.utilities.AreaRWD;

/**
 * @author jaf28
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class SpiderFeetMapper implements SpiderFeetMapperInterface {
    public HashMap getFootMapping(
        ConcreteUnitaryDiagram cud1,
        ConcreteUnitaryDiagram cud2) {

		// Compute the mapping spider->habitat for d1
        HashMap spidersToHabitats1 = new HashMap();
        HashMap feetToZones1 = new HashMap();
        Vector zAreas1 = new Vector(cud1.getConcreteZones());
        Vector zones1 = new Vector();
        // for each ConcreteZone, build an abstract Zone and maybe shade it
        for (int i = 0; i < zAreas1.size(); i++) {
            ConcreteZone za = (ConcreteZone) zAreas1.get(i);
            // Compute abstract zone
            Zone z = za.getAbstractZone();
            zones1.add(z);
        }
        Set spiders1 = cud1.getConcreteSpiders();
        Iterator si1 = spiders1.iterator();
        while (si1.hasNext()) {
            ConcreteSpider s = (ConcreteSpider) si1.next();
            //System.out.println("got spider " + s);
            // find out its habitat
            Vector habitat = new Vector();
            Set feet = s.getFeet();
            Iterator fi = feet.iterator();
            while (fi.hasNext()) {
                ConcreteSpiderFoot csf = (ConcreteSpiderFoot) fi.next();
                zoneSearch : for (int j = 0; j < zAreas1.size(); j++) {
                    AreaRWD a = ((ConcreteZone) zAreas1.get(j)).getArea();
                    if (a.contains(csf.getX(), csf.getY())) {
                        if (habitat.contains(zones1.get(j))) {
                            // should never get here : two feet in one zone
                            throw new IllegalArgumentException();
                        }
                        feetToZones1.put(csf, zones1.get(j));
                        csf.setZone(((Zone) zones1.get(j)).toString());
                        habitat.add(zones1.get(j));
                        break zoneSearch;
                    }
                }
            }
            System.out.println("habitat of spider in d1 is " + habitat);
            spidersToHabitats1.put(s, habitat);
        }

		// Compute the mapping spider->habitat for d2
        HashMap spidersToHabitats2 = new HashMap();
        HashMap feetToZones2 = new HashMap();
        Vector zAreas2 = new Vector(cud2.getConcreteZones());
        Vector zones2 = new Vector();

        // for each ConcreteZone, build an abstract Zone and maybe shade it
        for (int i = 0; i < zAreas2.size(); i++) {
            ConcreteZone za = (ConcreteZone) zAreas2.get(i);
            // Compute abstract zone
            Zone z = za.getAbstractZone();
            zones2.add(z);
        }
        Set spiders2 = cud2.getConcreteSpiders();
        Iterator si2 = spiders2.iterator();
        while (si2.hasNext()) {
            ConcreteSpider s = (ConcreteSpider) si2.next();
            //System.out.println("got spider " + s);
            // find out its habitat
            Vector habitat = new Vector();
            Set feet = s.getFeet();
            Iterator fi = feet.iterator();
            while (fi.hasNext()) {
                ConcreteSpiderFoot csf = (ConcreteSpiderFoot) fi.next();
                zoneSearch : for (int j = 0; j < zAreas2.size(); j++) {
                    AreaRWD a = ((ConcreteZone) zAreas2.get(j)).getArea();
                    if (a.contains(csf.getX(), csf.getY())) {
                        if (habitat.contains(zones2.get(j))) {
                            // should never get here : two feet in one zone
                            throw new IllegalArgumentException();
                        }
                        feetToZones2.put(csf, zones2.get(j));
                        csf.setZone(((Zone) zones2.get(j)).toString());
                        habitat.add(zones2.get(j));
                        break zoneSearch;
                    }
                }
            }
			System.out.println("habitat of spider in d2 is " + habitat);
            spidersToHabitats2.put(s, habitat);
        }
        
        // iterate through looking for matching spiders
        Vector spiders1ToPair = new Vector(spiders1);
        Vector spiders2ToPair = new Vector(spiders2);
        HashMap matchedSpiders = new HashMap();
        //System.out.println("pair up from " + spiders1 + " and " + spiders2);
        boolean hasMatched = true;
        searchForPair : while (hasMatched) {
            hasMatched = false;
            si1 = spiders1ToPair.iterator();
            s1search : while (si1.hasNext()) {
                ConcreteSpider s1 = (ConcreteSpider) si1.next();
                Vector hab1 = (Vector) spidersToHabitats1.get(s1);
                si2 = spiders2ToPair.iterator();
                s2search : while (si2.hasNext()) {
                    ConcreteSpider s2 = (ConcreteSpider) si2.next();
                    Vector hab2 = (Vector) spidersToHabitats2.get(s2);
                    //System.out.println("habs are " + hab1 + " and " + hab2);
                    if (hab1.containsAll(hab2) && hab2.containsAll(hab1)) {
                        matchedSpiders.put(s2, s1);
                        spiders1ToPair.remove(s1);
                        spiders2ToPair.remove(s2);
                        hasMatched = true;
                        continue searchForPair;
                    }

                }
            }
        }
        //System.out.println("matched " + matchedSpiders);
        HashMap result = new HashMap();
        // iterate through spiders2, finding spider in d1 sometimes,
        // and adding feet pairs to result where appropriate
        si2 = spiders2.iterator();
        while (si2.hasNext()) {
            ConcreteSpider s2 = (ConcreteSpider) si2.next();
            // see whether it is paired
            ConcreteSpider s1 = (ConcreteSpider) matchedSpiders.get(s2);
            //System.out.println("spider s1 is "+s1.hashCode()+" and s2 is "+s2.hashCode());
            if (s1 != null) {
                Iterator sf2 = s2.getFeet().iterator();
                while (sf2.hasNext()) {
                    ////////////////////////////////////////////////////////////////////////////
                    ConcreteSpiderFoot csf2 = (ConcreteSpiderFoot) sf2.next();
                    // find its zone
                    Zone z = (Zone) feetToZones2.get(csf2);
                    // find foot of s1 in same zone
                    Iterator sf1 = s1.getFeet().iterator();
                    foot1Search:
                    while (sf1.hasNext()) {
                        ////////////////////////////////////////////////////////////////////////
                        ConcreteSpiderFoot csf1 =
                            (ConcreteSpiderFoot) sf1.next();
                        // find its zone
                        Zone z1 = (Zone) feetToZones1.get(csf1);
                        if(z==z1){
                            // found matched feet
                            //System.out.println("mapping is now "+result);
                            //System.out.println("csf1 is "+csf1.hashCode());
                            //System.out.println("csf2 is "+csf2.hashCode());
                            
                            result.put(csf1,csf2);
                            //System.out.println("added a mapping");
                            //System.out.println("mapping is now "+result);
                            result.put(csf2,csf1); // inverse added JAF late 17th Dec
                            //System.out.println("added a mapping");
                            //System.out.println("mapping is now "+result);
                            break foot1Search;
                        }
                    }
                }
            }
        }
        //System.out.println("paired feet are "+result);
        return result;
    }
}
